﻿var captureCamera_estimatedResponse = 60;
var CurrImageIndex = 0;

var CameraImages = 
{
  0: "demodata/images/camera_01.jpg",
  1: "demodata/images/camera_02.jpg"
}

function API_captureCamera_commandDevice_Exec(dataObject, DeviceRecord, DetailsRecord, DetailsData)
{ 
  if (dataObject.data[0].command === "OnOff")
  {
    if ((dataObject.data[0].parameters.on === true) && (DetailsData.deviceOn === false))
    {
      return true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      return true;
    }
    else
    {
      return false;
    }    
  }
  else if (dataObject.data[0].command === "Register")
  {
    return true;
  }
  else
  {
    return false;  
  }  
}

function API_captureCamera_commandDevice_Done(dataObject, DeviceRecord, DetailsRecord, DetailsData)
{
  if (dataObject.data[0].command === "OnOff")
  {
    if ((dataObject.data[0].parameters.on === true) && (DetailsData.deviceOn === false))
    {
      DeviceRecord.set("deviceReport", Language.DemoData.Devices.CaptureCamera_General.deviceReport_On);
      DetailsData.deviceReport = Language.DemoData.Devices.CaptureCamera_General.deviceReport_On;
      DetailsData.deviceOn = true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      DetailsData.deviceReport = Language.DemoData.Devices.CaptureCamera_General.deviceReport_Off;
      DetailsData.deviceOn = false;
    }
  }
  else if (dataObject.data[0].command === "Register")
  {
    DeviceRecord.set("registered", true);
    DeviceRecord.set("deviceReport", Language.DemoData.Devices.CaptureCamera_General.deviceReport_On);
  
    DetailsData.registered = true;
    DetailsData.deviceReport = Language.DemoData.Devices.CaptureCamera_General.deviceReport_On;           
  }
}

function API_captureCamera_queryDeviceStatus_Exec(dataObject, DetailsRecord, DetailsData)
{

}

function API_captureCamera_queryDeviceStatus_Done(dataObject, DetailsRecord, DetailsData)
{
  CurrImageIndex++;
  DetailsData.data.imgURL = CameraImages[CurrImageIndex % 2];
}

function API_captureCamera_createDeviceByImplementationAndMsisdn_Exec(dataObject, responseData)
{
  ISOTimestamp = new Date().setTimezoneOffset(Date.today().getUTCOffset()).toString("yyyy-MM-ddTHH:mm:ssZ");

  responseData.deviceInfo.push
  (
    {
      status : "pending",
      deviceId : DemoStore_Devices.getCount() + 1,
      lastQuery : ISOTimestamp,
      lastResponse : ISOTimestamp,
      deviceImpl : "99",
      type : "captureCamera",
      deviceName : dataObject.data.name,
      deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
      estimatedReponseTime: captureCamera_estimatedResponse,
      registered : false,
      deviceOn : true
    }
  );

  responseData.deviceDetails.push
  (
    {
      status : "pending",
      deviceId : DemoStore_DeviceDetails.getCount() + 1,
      lastQuery : ISOTimestamp,
      lastResponse : ISOTimestamp,
      deviceImpl : "99",      
      type : "captureCamera",
      deviceName : dataObject.data.name,
      deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
      estimatedReponseTime: captureCamera_estimatedResponse,
      registered : false,
      deviceOn : true,
      data :
      {
        imgURL: "demodata/images/camera_02.jpg"
      }
    }
  );

  for (var i = 0; i < responseData.deviceInfo.length; i++) 
  {
    DemoStore_Devices.add(responseData.deviceInfo[i]);
  }

  for (var i = 0; i < responseData.deviceDetails.length; i++) 
  {
    DemoStore_DeviceDetails.add
    (
      {
        deviceId : responseData.deviceDetails[i].deviceId,
        details: Ext.encode
        (
          responseData.deviceDetails[i]
        )
      }
    );
  }

  // add the device specific message that will be shown to the user
  responseData.message = Language.DemoData.Devices.CaptureCamera_General.registration_message;
  responseData.estimatedResponse = captureCamera_estimatedResponse;
  return true;
}

function API_captureCamera_createDeviceByImplementationAndMsisdn_Done(dataObject, responseData)
{
  for (var i = 0; i < responseData.deviceDetails.length; i++) 
  {
    var DeviceRecord = DemoStore_Devices.findRecord("deviceId", responseData.deviceDetails[i].deviceId);
    RegistrationOK = false; //Math.random() > 0.5;
    
    if (DeviceRecord !== null)
    {
      if (RegistrationOK === true)
      {
        DeviceRecord.set("status", "OK");
        DeviceRecord.set("registered", true);
        DeviceRecord.set("estimatedReponseTime", 5);
        DeviceRecord.set("deviceReport", Language.DemoData.Devices.CaptureCamera_General.deviceReport_On);
      }
      else
      {
        DeviceRecord.set("status", "resumable");
        DeviceRecord.set("registered", false);
        DeviceRecord.set("deviceReport", Language.DemoData.Devices.CaptureCamera_General.registration_resumable);      
      }
    }

    var DeviceDetails = DemoStore_DeviceDetails.findRecord("deviceId", responseData.deviceDetails[i].deviceId);
    
    if (DeviceDetails !== null)
    {
      var DetailsData = Ext.decode(DeviceDetails.get("details"));
      
      if (RegistrationOK === true)
      {
        DetailsData.status = "OK";
        DetailsData.registered = true;
        DetailsData.deviceReport = Language.DemoData.Devices.CaptureCamera_General.deviceReport_On;
      }
      else
      {
        DetailsData.status = "resumable";
        DetailsData.registered = false;
        DetailsData.estimatedReponseTime = 5;
        DetailsData.deviceReport = Language.DemoData.Devices.CaptureCamera_General.registration_resumable;      
      }
      
      DeviceDetails.set("details", Ext.encode(DetailsData));
    }
  }

  return true;
}