﻿var switch_estimatedResponse = 30;
var CurrImageIndex = 0;

function API_switch_commandDevice_Exec(dataObject, DeviceRecord, DetailsRecord, DetailsData)
{ 
  if (dataObject.data[0].command === "OnOff")
  {
    if ((dataObject.data[0].parameters.on === true) && (DetailsData.deviceOn === false))
    {
      return true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  else
  {
    return false;  
  }  
}

function API_switch_commandDevice_Done(dataObject, DeviceRecord, DetailsRecord, DetailsData)
{
  if (dataObject.data[0].command === "OnOff")
  {
    if ((dataObject.data[0].parameters.on === true) && (DetailsData.deviceOn === false))
    {
      DeviceRecord.set("deviceReport", Language.DemoData.Devices.Switch_RemoteControl.deviceReport_On);
      DetailsData.deviceReport = Language.DemoData.Devices.Switch_RemoteControl.deviceReport_On;
      DetailsData.deviceOn = true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      DetailsData.deviceReport = Language.DemoData.Devices.Switch_RemoteControl.deviceReport_Off;
      DetailsData.deviceOn = false;
    }
  }
}

function API_switch_queryDeviceStatus_Exec(dataObject, DetailsRecord, DetailsData)
{

}

function API_switch_queryDeviceStatus_Done(dataObject, DetailsRecord, DetailsData)
{

}

function API_switch_createDeviceByImplementationAndMsisdn_Exec(dataObject, responseData)
{
  ISOTimestamp = new Date().setTimezoneOffset(Date.today().getUTCOffset()).toString("yyyy-MM-ddTHH:mm:ssZ");
  
  // add to virtual slaves
  for (var i = 1; i <= 2; i++) 
  {
    responseData.deviceInfo.push
    (
      {
        status : "pending",
        deviceId : DemoStore_Devices.getCount() + i,
        lastQuery : ISOTimestamp,
        lastResponse : ISOTimestamp,
        deviceImpl : "3",
        type : "switch",
        deviceName : dataObject.data.name + " #" + i.toString(),
        deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
        estimatedReponseTime: switch_estimatedResponse,
        registered : false,
        deviceOn : true
      }
    );

    responseData.deviceDetails.push
    (
      {
        status : "pending",
        deviceId : DemoStore_DeviceDetails.getCount() + i,
        lastQuery : ISOTimestamp,
        lastResponse : ISOTimestamp,
        deviceImpl : "3",
        type : "switch",
        deviceName : dataObject.data.name + " #" + i.toString(),
        deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
        estimatedReponseTime: switch_estimatedResponse,
        registered : false,
        deviceOn : true
      }
    );
  }

  // add physical master
  responseData.deviceInfo.push
  (
    {
      status : "pending",
      deviceId : DemoStore_Devices.getCount() + i,
      lastQuery : ISOTimestamp,
      lastResponse : ISOTimestamp,
      deviceImpl : "2",
      type : "switch",
      deviceName : dataObject.data.name,
      deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
      estimatedReponseTime: switch_estimatedResponse,
      registered : false,
      deviceOn : true
    }
  );

  responseData.deviceDetails.push
  (
    {
      status : "pending",
      deviceId : DemoStore_DeviceDetails.getCount() + i,
      lastQuery : ISOTimestamp,
      lastResponse : ISOTimestamp,
      deviceImpl : "2",
      type : "switch",
      deviceName : dataObject.data.name,
      deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
      estimatedReponseTime: switch_estimatedResponse,
      registered : false,
      deviceOn : true
    }
  );

  for (var i = 0; i < responseData.deviceInfo.length; i++) 
  {
    DemoStore_Devices.add(responseData.deviceInfo[i]);
  }

  for (var i = 0; i < responseData.deviceDetails.length; i++) 
  {
    DemoStore_DeviceDetails.add
    (
      {
        deviceId : responseData.deviceDetails[i].deviceId,
        details: Ext.encode
        (
          responseData.deviceDetails[i]
        )
      }
    );
  }

  // add the device specific message that will be shown to the user
  responseData.message = Language.DemoData.Devices.Switch_RemoteControl.registration_message;
  responseData.estimatedResponse = switch_estimatedResponse;
  return true;
}

function API_switch_createDeviceByImplementationAndMsisdn_Done(dataObject, responseData)
{
  for (var i = 0; i < responseData.deviceDetails.length; i++) 
  {
    var DeviceRecord = DemoStore_Devices.findRecord("deviceId", responseData.deviceDetails[i].deviceId);
    
    if (DeviceRecord !== null)
    {
      DeviceRecord.set("status", "OK");
      DeviceRecord.set("registered", true);
      DeviceRecord.set("deviceReport", Language.DemoData.Devices.Switch_RemoteControl.deviceReport_On);
    }

    var DeviceDetails = DemoStore_DeviceDetails.findRecord("deviceId", responseData.deviceDetails[i].deviceId);
    
    if (DeviceDetails !== null)
    {
      var DetailsData = Ext.decode(DeviceDetails.get("details"));
      
      DetailsData.status = "OK";
      DetailsData.registered = true;
      DetailsData.deviceReport = Language.DemoData.Devices.Switch_RemoteControl.deviceReport_On;
      
      DeviceDetails.set("details", Ext.encode(DetailsData));
    }
  }

  return true;
}