﻿var thermalSwitch_estimatedResponse = 40;

function API_thermalSwitch_commandDevice_Exec(dataObject, DeviceRecord, DetailsRecord, DetailsData)
{ 
  if (dataObject.data[0].command === "OnOff")
  {       
    if ((dataObject.data[0].parameters.on === true) && (DetailsData.deviceOn === false))
    {
      return true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  else if (dataObject.data[0].command === "SetTemp")
  {
    if (dataObject.data[0].parameters.on === true)
    {
      DetailsData.data.thermalMode = dataObject.data[0].parameters.thermalMode;
      DetailsData.data.required = dataObject.data[0].parameters.required;
      DeviceRecord.set("operationMode", "thermal");
      DetailsData.operationMode = "thermal";
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      DeviceRecord.set("operationMode", "manual");
      DetailsData.operationMode = "manual";
    }
    
    // success
    return true;
  }
  else
  {
    return false;  
  }  
}

function API_thermalSwitch_commandDevice_Done(dataObject, DeviceRecord, DetailsRecord, DetailsData)
{
  if (dataObject.data[0].command === "OnOff")
  {       
    if ((dataObject.data[0].parameters.on === true) && (DetailsData.deviceOn === false))
    {
      if (dataObject.data[0].parameters.thermalMode === "heating")
      {
        DeviceRecord.set("deviceReport", vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Heating, [DetailsData.data.required]));
      }
      else
      {
        DeviceRecord.set("deviceReport", vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Cooling, [DetailsData.data.required]));      
      }
      DetailsData.deviceReport = vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Heating, [DetailsData.data.required]);
      DetailsData.operationMode = "thermal";
      DetailsData.deviceOn = true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      DeviceRecord.set("deviceReport", Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Manual);
      DetailsData.deviceReport = Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Manual;
      DetailsData.operationMode = "manual";
      DetailsData.deviceOn = false;
    }
  }
  else if (dataObject.data[0].command === "SetTemp")
  {
    if (dataObject.data[0].parameters.on === true)
    {
      if (dataObject.data[0].parameters.thermalMode === "heating")
      {
        DeviceRecord.set("deviceReport", vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Heating, [DetailsData.data.required]));
      }
      else
      {
        DeviceRecord.set("deviceReport", vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Cooling, [DetailsData.data.required]));      
      }
      DetailsData.deviceReport = vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Heating, [DetailsData.data.required]);
      DetailsData.deviceOn = true;
    }
    else if ((dataObject.data[0].parameters.on === false) && (DetailsData.deviceOn === true))
    {
      DeviceRecord.set("deviceReport", Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Manual);
      DetailsData.deviceReport = Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Manual;
      DetailsData.deviceOn = false;
    }    
  }
}

function API_thermalSwitch_queryDeviceStatus_Exec(dataObject, DetailsRecord, DetailsData)
{

}

function API_thermalSwitch_queryDeviceStatus_Done(dataObject, DetailsRecord, DetailsData)
{

}

function API_thermalSwitch_createDeviceByImplementationAndMsisdn_Exec(dataObject, responseData)
{
  ISOTimestamp = new Date().setTimezoneOffset(Date.today().getUTCOffset()).toString("yyyy-MM-ddTHH:mm:ssZ");

  responseData.deviceInfo.push
  (
    {
      status : "pending",
      deviceId : DemoStore_Devices.getCount() + 1,
      lastQuery : ISOTimestamp,
      lastResponse : ISOTimestamp,
      deviceImpl : "1",
      type : "thermalSwitch",
      deviceName : dataObject.data.name,
      deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
      estimatedReponseTime: thermalSwitch_estimatedResponse,
      operationMode : "thermal",
      registered : false,
      deviceOn : true
    }
  );

  responseData.deviceDetails.push
  (
    {
      status : "pending",
      deviceId : DemoStore_DeviceDetails.getCount() + 1,
      lastQuery : ISOTimestamp,
      lastResponse : ISOTimestamp,
      deviceImpl : "1",
      type : "thermalSwitch",
      deviceName : dataObject.data.name,
      deviceReport : Language.DemoData.Common.Devices_Registration_InProcess,
      estimatedReponseTime: thermalSwitch_estimatedResponse,
      operationMode : "thermal",
      registered : false,
      deviceOn : true,
      data :
      {
        actual : 28,
        required : 26.0,
        thermalDeviceOn : false,
        thermalMode : "heating"
      }
    }
  );

  for (var i = 0; i < responseData.deviceInfo.length; i++) 
  {
    DemoStore_Devices.add(responseData.deviceInfo[i]);
  }

  for (var i = 0; i < responseData.deviceDetails.length; i++) 
  {
    DemoStore_DeviceDetails.add
    (
      {
        deviceId : responseData.deviceDetails[i].deviceId,
        details: Ext.encode
        (
          responseData.deviceDetails[i]
        )
      }
    );
  }

  // add the device specific message that will be shown to the user
  responseData.message = Language.DemoData.Devices.ThermalSwitch_TUTA.registration_message;
  responseData.estimatedResponse = thermalSwitch_estimatedResponse;
  return true;
}

function API_thermalSwitch_createDeviceByImplementationAndMsisdn_Done(dataObject, responseData)
{
  for (var i = 0; i < responseData.deviceDetails.length; i++) 
  {
    var DeviceRecord = DemoStore_Devices.findRecord("deviceId", responseData.deviceDetails[i].deviceId);
    
    if (DeviceRecord !== null)
    {
      DeviceRecord.set("status", "OK");
      DeviceRecord.set("registered", true);
      DeviceRecord.set("deviceReport", vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Heating, [responseData.deviceDetails[i].data.required]));
    }

    var DeviceDetails = DemoStore_DeviceDetails.findRecord("deviceId", responseData.deviceDetails[i].deviceId);
    
    if (DeviceDetails !== null)
    {
      var DetailsData = Ext.decode(DeviceDetails.get("details"));
      
      DetailsData.status = "OK";
      DetailsData.registered = true;
      DetailsData.deviceReport = vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Heating, [DetailsData.data.required]);
      
      DeviceDetails.set("details", Ext.encode(DetailsData));
    }
  }

  return true;
}