﻿var defaultExecuteTime = 5000;

function API_Simulate_login(dataObject, OnSuccess, OnFailure)
{
  OnSuccess
  (
    {
      status : "OK",
      data :
      {
        serverTime : "2012-05-02T19:23:38Z"
      },
      ver : "1.1"
    }
  );
}

function API_Simulate_getAccountData(dataObject, OnSuccess, OnFailure)
{
  var UnusedMISISDN = [];

  DemoStore_UnusedMISISDN.each(function(record)
  {
    UnusedMISISDN.push(record.get("number"));
  });
  
  OnSuccess
  (
    {
      status : "OK",
      data :
      {
        unregisteredDeviceMsisdns: UnusedMISISDN
      },
      ver : "1.1"
    }
  );  
}

function API_Simulate_getGroupInfo(dataObject, OnSuccess, OnFailure)
{
  var GroupsData = [];
  
  DemoStore_Groups.each(function(record)
  {
    GroupsData.push
    (
      {
        id : record.get("id"),
        name : record.get("name")
      }
    );
  });

  OnSuccess
  (
    {
      status : "OK",
      data : GroupsData,
      ver : "1.1"
    }
  );
}

function API_Simulate_getDeviceInfo(dataObject, OnSuccess, OnFailure)
{
  var DevicesData = [];

  DemoStore_Devices.each(function(record)
  {
    var DeviceInstance = {};
    
    Ext.each
    (
      DemoStore_Devices.model.prototype.fields.items,
      function(field)
      {
        DeviceInstance[field.name] = record.get(field.name);
      },
      this
    );
    
    // push the instance into the array
    DevicesData.push(DeviceInstance);
  });

  OnSuccess
  (
    {
      status : "OK",
      data : DevicesData,
      ver : "1.1"
    }
  );
}

function API_Simulate_getDeviceImplementationInfo(dataObject, OnSuccess, OnFailure)
{
  DeviceImplData = [];

  DemoStore_DeviceImpl.each(function(record)
  {
    DeviceImplData.push
    (
      {
        deviceImpl : record.get("deviceImpl"),
        masterDeviceImpl : record.get("masterDeviceImpl"),
        name : record.get("name"),
        type : record.get("type"),
        hiddenForUsage : record.get("hiddenForUsage"),
        hiddenForRegistration : record.get("hiddenForRegistration")
      }
    );
  });

  OnSuccess
  (
    {
      status : "OK",
      data : DeviceImplData,
      ver : "1.1"
    }
  );
}

function API_Simulate_getDeviceDetails(dataObject, OnSuccess, OnFailure)
{
  var Record = DemoStore_DeviceDetails.findRecord("deviceId", dataObject.data.deviceIds[0]);
  
  if (Record !== null)  
  {
    OnSuccess
    (
      {
        status : "OK",
        data :
        [
          Ext.decode(Record.get("details"))
        ],
        ver : "1.1"
      }
    );
  }
  else
  {
    OnSuccess
    (
      {
        status : "OK",
        ver : "1.1"
      }
    );
  }
}

function API_Simulate_queryDeviceStatus(dataObject, OnSuccess, OnFailure)
{
  var DetailsRecord = DemoStore_DeviceDetails.findRecord("deviceId", dataObject.data.deviceIds[0]);
  var DetailsData = Ext.decode(DetailsRecord.get("details"));
  DetailsData.status = "pending";

  // set the details for this DetailsRecord
  window["API_" + DetailsData.type +"_queryDeviceStatus_Exec"](dataObject, DetailsRecord, DetailsData);
  DetailsRecord.set("details", Ext.encode(DetailsData));

  OnSuccess
  (
    {
      status : "OK",
      data :
      [
        DetailsData
      ],
      ver : "1.1"
    }
  );

  setTimeout(function()
  {
    window["API_" + DetailsData.type +"_queryDeviceStatus_Done"](dataObject, DetailsRecord, DetailsData);
    
    DetailsData.status = "OK";
    DetailsRecord.set("details", Ext.encode(DetailsData));
  }, defaultExecuteTime);

}

function API_Simulate_commandDevice(dataObject, OnSuccess, OnFailure)
{
  var DeviceRecord = DemoStore_Devices.findRecord("deviceId", dataObject.data[0].deviceId);
  var FailureData =
  {
    status : "apiError",
    ver : "1.1"
  }

  if (DeviceRecord !== null)
  {
    var DetailsRecord = DemoStore_DeviceDetails.findRecord("deviceId", dataObject.data[0].deviceId);

    function finalizeCommand(DeviceRecord, DetailsRecord, DetailsData)
    {
      window["API_" + DetailsData.type +"_commandDevice_Done"](dataObject, DeviceRecord, DetailsRecord, DetailsData);
      
      DetailsData.status = "OK";
      DeviceRecord.set("status", "OK");
      DetailsRecord.set("details", Ext.encode(DetailsData));
    }

    if (DetailsRecord !== null)
    {
      var DetailsData = Ext.decode(DetailsRecord.get("details"));

      if (window["API_" + DetailsData.type +"_commandDevice_Exec"](dataObject, DeviceRecord, DetailsRecord, DetailsData) === true)
      {
        DetailsData.status = "pending";
        DeviceRecord.set("status", "pending");
        DetailsRecord.set("details", Ext.encode(DetailsData));

        setTimeout(function()
        {
          finalizeCommand(DeviceRecord, DetailsRecord, DetailsData);
        }, defaultExecuteTime);

        OnSuccess
        (
          {
            status : "OK",
            data :
            [
              DetailsData
            ],
            ver : "1.1"
          }
        );
      }
      else
      {
        OnFailure(FailureData);
      }
    }
    else
    {
      OnFailure(FailureData);
    }
  }
  else
  {
    OnFailure(FailureData);
  }
}

function API_Simulate_createDeviceByImplementationAndMsisdn(dataObject, OnSuccess, OnFailure)
{
  var DeviceImpl = DemoStore_DeviceImpl.findRecord("deviceImpl", dataObject.data.deviceImpl);  
  var FailureData =
  {
    status : "apiError",
    ver : "1.1"
  }
  
  if (DeviceImpl !== null)
  {
    var responseData = 
    {
      estimatedResponse: -1,
      deviceDetails: [],
      deviceInfo: [],
      message: ""
    };
    
    if (window["API_" + DeviceImpl.get("type") + "_createDeviceByImplementationAndMsisdn_Exec"](dataObject, responseData) === true)
    {
      setTimeout(function()
      {
        window["API_" + DeviceImpl.get("type") + "_createDeviceByImplementationAndMsisdn_Done"](dataObject, responseData);
      }, (responseData.estimatedResponse - 5) * 1000);
      
      OnSuccess
      (
        {
          ver : "1.1",
          status : "OK",
          data:
          {
            message : responseData.message,
            devices : responseData.deviceDetails
          }
        }
      );
    
    }
    else
    {
      OnFailure(FailureData);
    }
  }
  else
  {
    OnFailure(FailureData);
  }
}

function API_Simulate_updateDevice(dataObject, OnSuccess, OnFailure)
{
  var DeviceRecord = DemoStore_Devices.findRecord("deviceId", dataObject.data.deviceId);
  var FailureData =
  {
    status : "apiError",
    ver : "1.1"
  }

  if (DeviceRecord !== null)
  {
    var DetailsRecord = DemoStore_DeviceDetails.findRecord("deviceId", dataObject.data.deviceId);

    if (DetailsRecord !== null)
    {
      var DetailsData = Ext.decode(DetailsRecord.get("details"));
      
      DetailsData.deviceName = dataObject.data.deviceName;
      DetailsRecord.set("details", Ext.encode(DetailsData));
      DeviceRecord.set("deviceName", dataObject.data.deviceName);
      
      OnSuccess
      (
        {
          status : "OK",
          ver : "1.1",
          data : DetailsData
        }
      );    
    }
    else
    {
      OnFailure(FailureData);
    }
  }
  else
  {
    OnFailure(FailureData);
  }  
}

function API_Simulate_deleteDevice(dataObject, OnSuccess, OnFailure)
{
  if (dataObject.data.length > 0)
  {
    for(var i in dataObject.data) 
    {
      var DeviceRecord = DemoStore_Devices.findRecord("deviceId", dataObject.data[i]);
      
      if (DeviceRecord !== null)
      {
        // first remove the details record 
        var DetailsRecord = DemoStore_DeviceDetails.findRecord("deviceId", dataObject.data[i]);
        
        if (DetailsRecord !== null)
        {
          DemoStore_DeviceDetails.remove(DetailsRecord);
        }
        
        // now remove the device record also
        DemoStore_Devices.remove(DeviceRecord);
      }
    }

    OnSuccess
    (
      {
        status : "OK",
        ver : "1.1"
      }
    );
  }
  else
  {
    OnFailure
    (
      {
        status : "apiError",
        ver : "1.1"
      }
    );
  }
}

function API_Simulate_createGroup(dataObject, OnSuccess, OnFailure)
{
  var GroupData =
  {
    id : DemoStore_Groups.getCount() + 1,
    name : dataObject.data[0].name
  }

  // add the data to the store
  DemoStore_Groups.add(GroupData);

  OnSuccess
  (
    {
      status : "OK",
      data :
      [
        GroupData
      ],
      ver : "1.1"
    }
  );
}

function API_Simulate_updateGroup(dataObject, OnSuccess, OnFailure)
{
  var GroupData = DemoStore_Groups.findRecord("id", dataObject.data[0].id);

  if (GroupData !== null)
  {
    GroupData.set("name", dataObject.data[0].name);

    OnSuccess
    (
      {
        status : "OK",
        data :
        [
          {
            id : GroupData.get("id"),
            name : GroupData.get("name")
          }
        ],
        ver : "1.1"
      }
    );
  }
  else
  {
    OnFailure
    (
      {
        status : "apiError",
        ver : "1.1"
      }
    );
  }
}

function API_Simulate_deleteGroup(dataObject, OnSuccess, OnFailure)
{
  if (dataObject.data.length > 0)
  {
    for(var i in dataObject.data) 
    {
      var GroupData = DemoStore_Groups.findRecord("id", dataObject.data[i]);
      
      if (GroupData !== null)
      {
        DemoStore_Groups.remove(GroupData);
      }
    }

    OnSuccess
    (
      {
        status : "OK",
        ver : "1.1"
      }
    );
  }
  else
  {
    OnFailure
    (
      {
        status : "apiError",
        ver : "1.1"
      }
    );
  }
}

function API_Simulate_updateDeviceGroup(dataObject, OnSuccess, OnFailure)
{
  for (var i = 0; i < dataObject.data.length; i++)
  {
    var DeviceRecord = DemoStore_Devices.findRecord("deviceId", dataObject.data[i].deviceId);
    var FailureData =
    {
      status : "apiError",
      ver : "1.1"
    }

    if (DeviceRecord !== null)
    {
      var DetailsRecord = DemoStore_DeviceDetails.findRecord("deviceId", dataObject.data[i].deviceId);
      DeviceRecord.set("groupId", dataObject.data[i].groupId);

      if (DetailsRecord !== null)
      {
        DetailsData = Ext.decode(DetailsRecord.get("details"));
        DetailsData.groupId = dataObject.data[i].groupId;

        // encode the data back to the details store
        DetailsRecord.set("details", Ext.encode(DetailsData));
      }
      else
      {
        OnFailure(FailureData);
        return false;    
      }
    }
    else
    {
      OnFailure(FailureData);
      return false;    
    }
  }

  OnSuccess
  (
    {
      status : "OK",
      ver : "1.1"
    }
  );
}

function API_Simulate_createDemoUser(dataObject, OnSuccess, OnFailure)
{
  OnSuccess
  (
    {
      status : "OK",
      ver : "1.1"
    }
  );
}

/**********************************************************************
  UNUSED MISISDN STORE AND INITIAL STORE INITIALIZATION IF IT IS EMPTY
**********************************************************************/

var DemoStore_UnusedMISISDN = new Ext.data.Store(
{
  model: 'UnusedMISISDN',

  proxy:
  {
    type: 'memory'
  },
});

// initialize all the data
DemoStore_UnusedMISISDN.add
(
  { number : "38640920403" },
  { number : "38640123456" },
  { number : "38640121089" },
  { number : "38640122461" }
);

/**********************************************************************
  GROUPS DATA STORE AND INITIAL STORE INITIALIZATION IF IT IS EMPTY
**********************************************************************/

var DemoStore_Groups = new Ext.data.Store(
{
  model: 'Group',

  proxy:
  {
    type: 'memory'
  },
});

// initialize all the data
DemoStore_Groups.add
(
  {
    id : "1",
    name : Language.DemoData.Groups.name_1,
  },
  {
    id : "2",
    name : Language.DemoData.Groups.name_2,
  }
);

/**********************************************************************
  DEVICES IMPLEMENTATION DATA STORE AND 
  INITIAL STORE INITIALIZATION IF IT IS EMPTY
**********************************************************************/

var DemoStore_DeviceImpl = new Ext.data.Store(
{
  model: 'DeviceImpl',

  proxy:
  {
    type: 'memory'
  },
});

DemoStore_DeviceImpl.add
(
  {
    deviceImpl : "1",
    name: Language.DemoData.DeviceInfo.thermalSwitch_TUTA_name,
    type: "thermalSwitch",
    hiddenForUsage: false, 
    hiddenForRegistration: false
  },
  {
    deviceImpl: "99",
    name: Language.DemoData.DeviceInfo.captureCamera_general_name,
    type: "captureCamera",
    hiddenForUsage: false, 
    hiddenForRegistration: false
  },
  {
    deviceImpl: "2",
    name: Language.DemoData.DeviceInfo.switch_remoteControl_name,
    type: "switch",
    hiddenForUsage: true, 
    hiddenForRegistration: false
  },
  {
    deviceImpl: "3",
    masterDeviceImpl: "2",
    name: Language.DemoData.DeviceInfo.switch_remoteControl_name,
    type: "switch",
    hiddenForUsage: false, 
    hiddenForRegistration: true
  }
);

/**********************************************************************
  DEVICES BASIC DATA TEMPLATES AND IMPLEMENTATIONS
**********************************************************************/

var Demo_DevicesArray = 
{
  index: { "1": 0, "2": 1, "3": 2, "4": 3, "5": 4 },
  data:
  [
    {
      status : "OK",
      deviceId : "1",
      groupId : "1",
      lastQuery : "2012-05-02T10:18:40Z",
      lastResponse : "2012-05-02T10:18:48Z",
      deviceImpl : "1",
      type : "thermalSwitch",
      deviceName : Language.DemoData.Devices.ThermalSwitch_TUTA.deviceName_1,
      deviceReport : vsprintf(Language.DemoData.Devices.ThermalSwitch_TUTA.deviceReport_Cooling, [26]),
      operationMode : "thermal",
      estimatedReponseTime: 5,
      registered : true,
      deviceOn : true
    },
    {
      status : "OK",
      deviceId : "2",
      groupId : "2",
      lastQuery : "2012-05-02T10:18:40Z",
      lastResponse : "2012-05-02T10:18:48Z",
      deviceImpl : "99",
      type : "captureCamera",
      deviceName : Language.DemoData.Devices.CaptureCamera_General.deviceName_1,
      deviceReport : Language.DemoData.Devices.CaptureCamera_General.deviceReport_On,
      estimatedReponseTime: 10,
      registered : true,
      deviceOn : true
    },
    {
      status : "noResponse",
      deviceId : "3",
      groupId : "2",
      lastQuery : "2012-05-02T10:18:40Z",
      lastResponse : "2012-05-02T10:18:48Z",
      deviceImpl : "3",
      type : "switch",
      deviceName : Language.DemoData.Devices.Switch_RemoteControl.deviceName_1,
      deviceReport : Language.DemoData.Devices.Switch_RemoteControl.deviceReport_On,
      estimatedReponseTime: 5,
      registered : true,
      deviceOn : true
    },
    {
      status : "OK",
      deviceId : "4",
      groupId : "2",
      lastQuery : "2012-05-02T10:18:40Z",
      lastResponse : "2012-05-02T10:18:48Z",
      deviceImpl : "3",
      type : "switch",
      deviceName : Language.DemoData.Devices.Switch_RemoteControl.deviceName_2,
      deviceReport : Language.DemoData.Devices.Switch_RemoteControl.deviceReport_Off,
      estimatedReponseTime: 5,
      registered : true,
      deviceOn : false
    },
    {
      status : "OK",
      deviceId : "5",
      groupId : "2",
      lastQuery : "2012-05-02T10:18:40Z",
      lastResponse : "2012-05-02T10:18:48Z",
      deviceImpl : "2",
      type : "switch",
      deviceName : Language.DemoData.Devices.Switch_RemoteControl.deviceName_0,
      estimatedReponseTime: 5,
      registered : true,
      deviceOn : false
    }
  ]
};

/**********************************************************************
  DEVICES DATA STORE AND INITIAL STORE INITIALIZATION IF IT IS EMPTY
**********************************************************************/

var DemoStore_Devices = new Ext.data.Store(
{
  model: 'Device',

  proxy:
  {
    type: 'memory'
  },
});

// initialize all the data
var TempDataArray = Demo_DevicesArray.data.slice(0);
DemoStore_Devices.add(TempDataArray);

/************************************************************************
  DEVICES DETAILS STORE AND INITIAL STORE INITIALIZATION IF IT IS EMPTY
************************************************************************/

var DemoStore_DeviceDetails = new Ext.data.Store(
{
  model: 'DeviceDetails',

  proxy:
  {
    type: 'memory'
  },
});


function AddDeviceDetails(deviceId, DetailsData)
{
  var index = Demo_DevicesArray.index[deviceId];
  var DeviceData = Demo_DevicesArray.data[index];
  
  if (DetailsData !== null) 
  {
    DeviceData.data = DetailsData;
  }
  
  return DeviceData;
}

// initialize all the data
DemoStore_DeviceDetails.add
(
  {
    deviceId : "1",
    details: Ext.encode
    (
      AddDeviceDetails
      (
        "1",
        {
          actual : 28,
          required : 26,
          thermalDeviceOn : true,
          thermalMode : "cooling"
        }
      )
    )
  },
  {
    deviceId : "2",
    details: Ext.encode
    (
      AddDeviceDetails
      (
        "2",
        {
          imgURL: "demodata/images/camera_01.jpg"
        }
      )
    )
  },
  {
    deviceId : "3",
    details: Ext.encode
    (
      AddDeviceDetails("3", null)
    )
  },
  {
    deviceId : "4",
    details: Ext.encode
    (
      AddDeviceDetails("4", null)
    )
  },
  {
    deviceId : "5",
    details: Ext.encode
    (
      AddDeviceDetails("5", null)
    )
  }
);