﻿var AddDeviceForms =
{
  "1": { cardId: 0 },
  "4": { cardId: 1 },
  "5": { cardId: 1 },
  "2": { cardId: 2 },
  "99": { cardId: 3 }
};

AddDeviceTypeForm =
{
  id: 'ID_AddDeviceTypeForm',
  cls: 'CS_AddDeviceTypeForm',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,
  items:
  [
    {
      cls: 'CS_Fieldset_AddDeviceType',
      xtype: "fieldset",
      title: Language.Application.AddDeviceType_Room,
      items:
      [
        {
          name: "groupId",
          id: 'ID_deviceGroup_dropdown',
          cls: 'CS_dropdown_selector',
          xtype: "selectfield",
          store: GroupDataStore,
          placeHolder: Language.Application.AddDevice_NoRooms,
          displayField:'name',
          valueField:'id'
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDeviceType',
      xtype: "fieldset",
      title: Language.Application.AddDeviceType_Type,
      items:
      [
        {
          name: 'deviceType',
          id: 'ID_deviceType_dropdown',
          cls: 'CS_dropdown_selector',
          xtype: 'selectfield',
          store: RegisterDeviceImplDataStore,
          placeHolder: Language.Application.AddDevice_NoDevices,
          displayField:'name',
          valueField:'deviceImpl'
        }
      ]
    }
  ],

  dockedItems:
  [
    {
      id: 'ID_BTN_AddDeviceType_Submit',
      cls: 'CS_BTN_ConfirmAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.AddDeviceType_Submit,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',	
      handler: function()
      {
        var values = Ext.getCmp('ID_AddDeviceTypeForm').getValues();

        if (!!values.deviceType)
        {
          DeviceImpl = RegisterDeviceImplDataStore.findRecord("deviceImpl", values.deviceType);
          DoSelectSettingsState(SettingsStates.AddDeviceForm, 'ID_AddDeviceForm', true);
          AddDeviceTypeAndGroup.SetDeviceImpl(values.deviceType);
          AddDeviceTypeAndGroup.SetDeviceGroup(values.groupId);

          if (DeviceImpl !== null)
          {
            Ext.getCmp('ID_AppSettingsNav').SetTitle(DeviceImpl.get("name"));
          }
          
          // set the correct active addDevice form panel
          Ext.getCmp('ID_AddDevice_Panel').setActiveItem(AddDeviceForms[DeviceImpl.get("deviceImpl")].cardId);
          Ext.getCmp('ID_AddDevice_Panel').getActiveItem().Initialize();
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Common_Form_FillAllFields);
        }
      }
    }
  ]
};

AddDevicePanel =
{
  id: 'ID_AddDevice_Panel',
  cls: 'CS_AddDevice_Panel',
  xtype: 'panel',
  layout: 'card',

  items:
  [
    AddDeviceTutaS30Socket,
    AddDeviceStripsSocket,
    AddDeviceSmartehGM2,
    AddDeviceCaptureCamera
  ],

  dockedItems:
  [
    {
      id: 'ID_BTN_AddDevice_Submit',
      cls: 'CS_BTN_ConfirmAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.AddDevice_Submit,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',	
      handler: function()
      {
        var ActiveRegistration = Ext.getCmp('ID_AddDevice_Panel').getActiveItem();
        
        if (ActiveRegistration.isFormValid())
        {
          function SignalSuccess(responseDetails)
          {
            if (responseDetails.data.devices)
            {
              for (var i = 0; i < responseDetails.data.devices.length; i++)
              {
                responseDetails.data.devices[i].groupId = AddDeviceTypeAndGroup.GetDeviceGroup();
                DeviceList.AddDeviceData(responseDetails.data.devices[i]);

                // start periodically checking for changes in the device registration
                PeriodicallyCheckDevice(responseDetails.data.devices[i].deviceId, responseDetails.data.devices[i].estimatedReponseTime, 1);
              }
            }

            Ext.getCmp('ID_BTN_AddDevice_Submit').enable(true);
            MainPanel.setLoading(false);
            Ext.Msg.alert
            (
              Language.Application.Common_Info,
              responseDetails.data.message,
              function()
              {
                Ext.getCmp(ActiveRegistration.getFormName()).reset();
                SettingsBackButtonClick();
                SettingsBackButtonClick();
              }
            );
          }

          Ext.getCmp('ID_BTN_AddDevice_Submit').disable(true);
          MainPanel.setLoading(true, true);          
          API.Call
          (
            'createDeviceByImplementationAndMsisdn',
            ActiveRegistration.getAddDeviceProps(),
            function(responseDetails)
            {
              updateDevicesGroupList = [];

              if ((AddDeviceTypeAndGroup.GetDeviceGroup() !== null) && (AddDeviceTypeAndGroup.GetDeviceGroup() !== ""))
              {
                if (responseDetails.data.devices)
                {
                  for (var i = 0; i < responseDetails.data.devices.length; i++)
                  {
                    updateDevicesGroupList.push
                    (
                      {
                        deviceId: responseDetails.data.devices[i].deviceId,
                        groupId: AddDeviceTypeAndGroup.GetDeviceGroup()
                      }
                    );
                  }
                }

                if (updateDevicesGroupList.length > 0)
                {
                  API.Call
                  (
                    'updateDeviceGroup',
                    updateDevicesGroupList,
                    function(responseUpdateGroup)
                    {
                      SignalSuccess(responseDetails);
                    },
                    function(responseUpdateGroup)
                    {
                      Ext.getCmp('ID_BTN_AddDevice_Submit').enable(true);
                      MainPanel.setLoading(false);                      
                      Ext.Msg.alert
                      (
                        Language.Application.Common_Error,
                        Language.Application.AddDevice_UpdateGroupError,
                        function()
                        {
                          Ext.getCmp(ActiveRegistration.getFormName()).reset();
                        }
                      );
                    },
                    function(responseUpdateGroup)
                    {
                      Ext.getCmp('ID_BTN_AddDevice_Submit').enable(true);
                    }
                  );
                }
                else
                {
                  SignalSuccess(responseDetails);
                  MainPanel.setLoading(false);
                }
              }
              else
              {
                SignalSuccess(responseDetails);
              }
            },
            function(responseDetails)
            {
              Ext.getCmp('ID_BTN_AddDevice_Submit').enable(true);
              MainPanel.setLoading(false);
              
              Ext.Msg.alert
              (
                Language.Application.Common_Error,
                Language.Application.AddDevice_AddDeviceError,
                function()
                {
                  Ext.getCmp(ActiveRegistration.getFormName()).reset();
                }
              );
            },
            function(responseDetails)
            {
              Ext.getCmp('ID_BTN_AddDevice_Submit').enable(true);
            }
          );
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Common_Form_FillAllFields);
        }
      }
    }
  ]
};