﻿AddGroupForm =
{
  id: 'ID_AddGroupForm',
  cls: 'CS_AddGroupForm',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,
  items:
  [
    {
      cls: 'CS_Fieldset_AddGroup',
      xtype: "fieldset",
      title: Language.Application.AddGroup_Name,
      items:
      [
        {
          name: "name",
          xtype: "textfield"
        }
      ]
    }
  ],
  
  dockedItems:
  [
    {
      id: 'ID_BTN_AddGroup_Submit',
      cls: 'CS_BTN_ConfirmAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.AddGroup_Submit,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',	
      handler: function()
      {
        var values = Ext.getCmp('ID_AddGroupForm').getValues();
        
        if(!!values.name)
        {
          Ext.getCmp('ID_BTN_AddGroup_Submit').disable(true);
          MainPanel.setLoading(true, true);
          
          API.Call
          (
            'createGroup',
            [
              {
                name: values.name
              }
            ],
            function(Response)
            {
              Ext.getCmp('ID_BTN_AddGroup_Submit').enable(true);
              MainPanel.setLoading(false);
              
              GroupDataStore.add(
              {
                "id": Response.data[0].id,
                "name": Response.data[0].name
              });
              
              Ext.Msg.alert
              (
                Language.Application.Common_Info,
                Language.Application.AddGroup_AddGroupSuccess,
                function()
                {
                  SettingsBackButtonClick();
                }
              );
            },
            function(Response)
            {
             Ext.getCmp('ID_BTN_AddGroup_Submit').enable(true);
              MainPanel.setLoading(false);              
              
              Ext.Msg.alert
              (
                Language.Application.Common_Error,
                Language.Application.AddGroup_AddGroupError,
                function()
                {
                  Ext.getCmp('ID_AddGroupForm').reset();
                }
              );
            },
            function(Response)
            {
              Ext.getCmp('ID_BTN_AddGroup_Submit').enable(true);
            }
          );
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.AddGroup_EnterGroupName);
        }
      }
    }  
  ]
};