﻿var SettingsStates =
{
  "SettingsList": { cardId: 0, Title: Language.Application.Settings_Title },
  "AddDeviceTypeForm": { cardId: 1, Title: Language.Application.Settings_AddDevice },
  "AddDeviceForm": { cardId: 2, Title: Language.Application.Settings_AddDevice },
  "EditDeviceList": { cardId: 3, Title: Language.Application.Settings_EditDevice },
  "EditDeviceForm": { cardId: 4, Title: Language.Application.Settings_EditDevice },
  "AddGroupForm": { cardId: 5, Title: Language.Application.Settings_AddGroup },
  "EditGroupList": { cardId: 6, Title: Language.Application.Settings_EditGroup },
  "EditGroupForm": { cardId: 7, Title: Language.Application.Settings_EditGroup },
  "MiscSettingsForms": { cardId: 8, Title: Language.Application.Settings_MiscSettings }
};

var settingsStateHistory = [];
var settingsCurrentState = null;

function setSettingsNextState(State)
{
  settingsStateHistory.push(settingsCurrentState);
  settingsCurrentState = State;  
}

function SetSettingsPreviousState()
{
  if (settingsStateHistory.length > 0)
  {
    settingsCurrentState = settingsStateHistory.pop();
    return settingsCurrentState;
  }
  else
  {
    return null;
  }
}

function SettingsBackButtonClick()
{
  var PreviousState = SetSettingsPreviousState();
    
  if (PreviousState !== null)
  {
    Ext.getCmp('ID_AppSettingsContainer_Panel').setActiveItem(PreviousState.cardId);
    Ext.getCmp('ID_AppSettingsNav').SetTitle(PreviousState.Title);
  }
  else
  {
    MainPanel.setActiveItem(SetAppPreviousState());                
  }
}

function DoSelectSettingsState(nextState)
{ 
  Ext.getCmp('ID_AppSettingsContainer_Panel').setActiveItem(nextState.cardId);
  Ext.getCmp('ID_AppSettingsNav').SetTitle(nextState.Title);
  setSettingsNextState(nextState);
}

AppSettings = 
{
  tpl:
  [
    '<div id="ID_appSettings_List">',
      '<tpl for=".">',
        '<div class="CS_appSettings_Wrapper" execute="{Execute}">',
          '<div class="CS_appSettings_Desc">{Description}</div>',
          '<div class="CS_appsettings_Arrow"><img src="images/btn_arrow.png"/></div>',
        '</div>',
      '</tpl>',
    '</div>'
  ],
  
  selModel:{
    mode: 'SINGLE',
    allowDeselect: true
  },

  id: 'ID_AppSettingsList',
  cls: 'CS_AppSettingsList',
  itemCls: 'CS_AppSettingsItem',
  selectedItemCls: 'CS_AppSettingsItem_Selected',
  itemSelector:'div.CS_appSettings_Wrapper',
  padding: "0px 5px 0px 5px",
  xtype: 'dataview',

  store: new Ext.data.Store(
  {
      model: 'AppSettings',
      data: 
      [
        {Description: Language.Application.Settings_AddDevice, Execute: 'addDevice'},
        {Description: Language.Application.Settings_EditDevice, Execute: 'editDevice'},
        {Description: Language.Application.Settings_AddGroup, Execute: 'addRoom'},
        {Description: Language.Application.Settings_EditGroup, Execute: 'editRoom'},
        {Description: Language.Application.Settings_MiscSettings, Execute: 'miscSettings'}
      ]
  }),
  
  listeners:
  {
    itemtap: function (view, index, item, e)
    {
      var Execute = Ext.get(item).getAttribute("execute");
      switch(Execute)
      {
        case "addDevice":
          AddDeviceTypeAndGroup.LoadDeviceData
          (
            function(success)
            { 
              DoSelectSettingsState(SettingsStates.AddDeviceTypeForm);
            }
          );
          break;
        case "editDevice":
          CallGetGroupInfo
          (
            function(success)
            {
              DoSelectSettingsState(SettingsStates.EditDeviceList);
              FilteredDeviceList.Get(null, null);
            }
          );
          break;
        case "addRoom":
          DoSelectSettingsState(SettingsStates.AddGroupForm);
          break;
        case "editRoom":
          DoSelectSettingsState(SettingsStates.EditGroupList);
          CallFilteredGroupList(null);
          break;
        case "miscSettings":
          DoSelectSettingsState(SettingsStates.MiscSettingsForms);
          break;
      }
    }
  }
};

AppSettingsPanel =
{
  id: 'ID_AppSettings_Panel',
  cls: 'CS_AppSettings_Panel',
  xtype: 'panel',
  layout:
  {
    type: 'vbox',
    pack: 'center',
    align: 'stretch'
  },

  items:
  [
    {
      title: Language.Application.Settings_Title,
      xtype: 'BackNavigation',
      id: 'ID_AppSettingsNav',
      handler: function()
      {
        SettingsBackButtonClick();
      }
    },
    {
      id: 'ID_AppSettingsContainer_Panel',
      cls: 'CS_AppSettingsContainer_Panel',
      layout: 'card',
  
      flex: 1,
      items:
      [
        AppSettings,
        AddDeviceTypeForm,
        AddDevicePanel,
        EditDeviceList,
        EditDeviceForm,
        AddGroupForm,
        EditGroupList,
        EditGroupForm,
        MiscSettingsForms
      ]
    }
  ]
};