﻿var LoggedUser = (function()
{
  var LoggedIn = false;

  /*class constructor.*/
  function Initialize()
  {
    var self = this;
  }

  Initialize.CleanupUserData = function()
  {
    TimersList.each(function(key, item)
    {
      clearTimeout(item);
    });
    
    FilteredDeviceList.Clear();
    DeviceImplList.Clear();
    TimersList.clear();
    DeviceList.Clear();
    GroupList.Clear();
  }

  Initialize.Login = function(UserName, Password, OnCompleteCallback, OnSuccessCallback, OnWrongLoginCallback, OnFailureCallback)
  {
    API.Call
    (
      "login",
      {
        user: UserName,
        pass: Password
      },
      function(Response)
      {
        if (Response.status === "OK")
        {
          Initialize.CleanupUserData();
          LoggedIn = true;

          OnCompleteCallback(true);
          OnSuccessCallback(Response);
        }
        else
        {
          OnCompleteCallback(true);
          OnWrongLoginCallback(true);
        }
      },
      function(Response)
      {
        OnCompleteCallback(false);
        OnFailureCallback(Response);
      }
    );
  };

  Initialize.Logout = function()
  {
    Initialize.CleanupUserData();
    LoggedIn = false;
  };

  Initialize.LoggedIn = function()
  {
    return LoggedIn;
  };

  return Initialize;
})();


AuthPanel =
{
  id: 'ID_Auth_Panel',
  scroll: "vertical",
  layout:
  {
    type : 'vbox',
    align: 'stretch',
    pack: 'center'
  },

  items:
  [
    {
      xtype: 'panel',
      height: 60,
      layout:
      {
        type: 'hbox'
      },
      items:
      [
        {
          cls: 'CS_Logout_Container',
          // padding: "0px 5px 0px 5px",
          height: 77,
          flex: 1,
          layout:
          {
            type: 'hbox',
            pack: 'left'
          },
          items:
          [
            {
              id: 'ID_Back_Button',
              cls:"CS_Back_Button",
              xtype: 'BackButton',
              text: Language.Application.Common_Bnt_Back,
              handler: function()
              {
                MainPanel.setActiveItem(SetAppPreviousState());
              }
            },
			{
			  // id: this.titleId,
			  cls: "appStateTitleContainer",
			  html: '<div class="appStateTitle"><p>' + Language.Application.Auth_Logon + '</p></div>',
			  height: 60,
			  flex: 2
			},
            {
			  xtype: 'panel',
              html: '<img class="CS_Logo_Small" src="images/logo_small.png">',
              height: 60,
              width: 48,
			  flex: 1,
            }
          ]
        }
      ]
    },
    {
      id: 'ID_SM_LoginForm',
      csl: 'CS_SM_LoginForm',

      xtype: 'formpanel',
      flex: 1,

      layout:
      {
        type: 'vbox',
        pack: 'center'
      },
      items:
      [
        {
          id: 'ID_Auth_UserName',
          cls: 'CS_Auth_Field',
          xtype: 'fieldset',
          title: Language.Application.Auth_Username,
          items:
          [
            {
              id: 'ID_Auth_Field_UserName',
              autoComplete: false,
              xtype: 'textfield',
              name: 'UserName'
            }
          ]
        },
        {
          id: 'ID_Auth_Password',
          cls: 'CS_Auth_Field',
          xtype: 'fieldset',
          title: Language.Application.Auth_Password,
          items:
          [
            {
              id: 'ID_Auth_Field_Password',
              autoComplete: false,
              xtype: 'textfield',
              name: 'Password'
            }
          ]
        },
        {
          id: 'ID_Auth_RememberMe',
          cls: 'CS_Auth_Field',
          xtype: 'fieldset',
          items:
          [
            {
              id: 'ID_Login_RememberMe',
              html:
              [
                '<table>',
                  '<tr>',
                    '<td class="CS_Auth_CheckBox_Value">',
                      '<span class="custom-checkbox">',
                        '<input id="ID_Auth_CheckBox_Field" type="checkbox" checked/>',
                        '<span class="box"><span class="tick"></span></span>',
                      '</span>',
                    '</td>',
                    '<td class="CS_Auth_CheckBox_Label">' + Language.Application.Auth_RememberMe + '</td>',
                  '</tr>',
                '</table>'
              ],
              listeners:
              {
                afterrender: function(panel)
                {
                  // set the password field as password type so that the characters do not show
                  var Elements = getElementsByClass('x-input-text', document.getElementById('ID_Auth_Field_Password'), 'input');
                  Elements[0].setAttribute('type','password');

                  // set the remember checkbox state as it was the last time     
                  var RememberCheckBox = document.getElementById("ID_Auth_CheckBox_Field");
                  RememberCheckBox.checked = mainSettings.GetRememberMe();

                  Ext.fly(RememberCheckBox).on('tap', function(evt, el, o)
                  {
                    mainSettings.SetRememberMe(!RememberCheckBox.checked);
                  });

                  if (mainSettings.GetRememberMe() === true)
                  {
                    Ext.getCmp('ID_SM_LoginForm').setValues(
                    {
                      UserName: mainSettings.GetUserName(),
                      Password: mainSettings.GetPassword()
                    });
                  }
                  else
                  {
                    Ext.getCmp('ID_SM_LoginForm').setValues(
                    {
                      UserName: "",
                      Password: ""
                    });
                  }
                }
              }
            }
          ]
        },
        {
          id: 'ID_Auth_Login',
          cls: 'CS_Auth_Field',
          xtype: 'fieldset',
		  margin: "5px 0px",
          // height: 43,
          items:
          [
            {
              id: 'ID_Login_Button',
              cls: 'CS_BTN_ConfirmAction',
              ui: 'confirm',
              xtype: 'button',
              // align: 'right',
              text: Language.Application.Auth_Logon,
	  height: 43,
	  // height: 60,
	  // margin: "0px 5px 5px 5px",
	  // html: '<img src="images/btn_arrow.png" class="arrow_right" />',
              handler: function()
              {
                if (debugOn === true)
                {
                  Ext.getCmp('ID_SM_LoginForm').setValues(
                  {
                    UserName: DebugUserName,
                    Password: DebugPassword
                  });
                }

                // get login form values
                var Values = Ext.getCmp('ID_SM_LoginForm').getValues();

                if(!!Values.UserName)
                {
                  MainPanel.setLoading(true, true);

                  LoggedUser.Login
                  (
                    Values.UserName,
                    Values.Password,

                    function OnComplete(success)
                    {
                      MainPanel.setLoading(false);
                    },

                    function OnSuccess(Response)
                    {
                      RememberCheckBox = document.getElementById("ID_Auth_CheckBox_Field");

                      if (RememberCheckBox.checked === true)
                      {
                        mainSettings.SetUserName(Values.UserName);
                        mainSettings.SetPassword(Values.Password);
                      }
                      else
                      {
                        Ext.getCmp('ID_SM_LoginForm').setValues(
                        {
                          UserName: "",
                          Password: ""
                        });
                      }

                      setAppNextState(ApplicationStates.MainMenu);
                      MainPanel.setActiveItem(ApplicationStates.MainMenu);
                    },

                    function OnWrongLogin(Response)
                    {
                      if (Response.status !== 0)
                      {
                        Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Auth_WrongLogin);
                      }
                    },

                    function OnFailure(Response)
                    {
                      if (Response.status !== 0)
                      {
                        Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Auth_LoginFailed);
                      }
                    }
                  );
                }
                else
                {
                  Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Auth_EnterAllData);
                }
              }
            }
          ]
        }
      ]
    }
  ]
};