DemoRegisterPanel =
{
  id: 'ID_DemoRegisterPanel',
  scroll: "vertical",
  layout:
  {
    type : 'vbox',
    align: 'stretch',
    pack: 'center'
  },

  items:
  [
    {
      xtype: 'panel',
      height: 60,
      layout:
      {
        type: 'hbox'
      },
      items:
      [
        {
          cls: 'CS_Logout_Container',
          padding: "0px 5px 0px 5px", 
          height: 77,
          flex: 1,
          layout:
          {
            type: 'hbox',
            pack: 'left'
          },
          items:
          [
            {
              id: 'ID_BTN_DemoRegister_Back',
              cls:"CS_Back_Button",
              xtype: 'BackButton',
              text: Language.Application.Common_Bnt_Back,
              handler: function()
              {
                MainPanel.setActiveItem(SetAppPreviousState());
              }
            },
            {
              xtype:"spacer"
            },
            {
              html: '<img class="CS_Logo_Small" src="images/logo_small.png">',
              height: 60,
              width: 48,
              style:
              {
                marginTop: '10px'
              }
            }
          ]
        }
      ]
    },
    {
      id: 'ID_Demo_RegisterForm',
      csl: 'CS_Demo_RegisterForm',

      xtype: 'formpanel',
      scroll: "vertical",
      bodyPadding: 0,
      padding: 6,
      flex: 1,

      items:
      [
        {
          xtype: "fieldset",
          instructions: Language.Application.Demo_Instruction,
          items:
          [
            {
              label: Language.Application.Demo_Email,
              xtype: "emailfield",
              name: 'Email',
            },
            {
              label: Language.Application.Demo_FirstName,
              xtype: "textfield",
              name: 'FirstName',
            },
            {
              label: Language.Application.Demo_LastName,
              xtype: "textfield",
              name: 'LastName',
            }
          ]
        }
      ]
    }
  ],

  dockedItems:
  [
    {
      dock: 'bottom',
      xtype: "button",
      id: 'ID_BTN_DR_Later',
      text: Language.Application.Demo_Later,
      height: 45,
      margin: "0px 5px 5px 5px",
      handler: function()
      {
        setAppNextState(ApplicationStates.MainMenu);
        MainPanel.setActiveItem(ApplicationStates.MainMenu);
        appStateHistory.pop();
      }
    },
    {
      dock: 'bottom',
      xtype: "button",
      id: 'ID_BTN_DR_Submit',
      cls: 'CS_BTN_ConfirmAction',            
      text: Language.Application.Demo_Submit,
      ui: "confirm",
      height: 45,
      margin: "0px 5px 5px 5px",
      handler: function()
      {
        // get register form values
        var Values = Ext.getCmp('ID_Demo_RegisterForm').getValues();

        if (!!Values.Email && !!Values.FirstName && !!Values.LastName)
        {
          MainPanel.setLoading(true, true);

          if (mainSettings.isPhoneGapAvailable())
          {
            MyuserAgentInfo =
            {
              type: "phonegap",
              data:
              {
                myHomeVersion: "1.0",
                deviceName: device.name,
                devicePhonegap: sdevice.cordova,
                devicePlatform: device.platform,
                deviceUuid: device.uuid,
                deviceVersion: device.version
              }
            }
          }
          else
          {
            MyuserAgentInfo =
            {
              type: "browser",
              data:
              {
                myHomeVersion: "1.0"
              }
            }
          }

          API.Call
          (
            "createDemoUser",
            {
              email: Values.Email,
              firstName: Values.FirstName,
              lastName: Values.LastName,
              userAgentInfo: MyuserAgentInfo
            },
            function(Response)
            {
              MainPanel.setLoading(false);

              if (Response.status === "OK")
              {
                mainSettings.SetIsDemoUserRegistered(true);
                setAppNextState(ApplicationStates.MainMenu);
                MainPanel.setActiveItem(ApplicationStates.MainMenu);
                appStateHistory.pop();
              }
              else
              {
                alert(Language.Application.Demo_RegisterError);
              }
            },
            function(Response)
            {
              MainPanel.setLoading(false);
              Ext.Msg.alert("","createDemoUser failed!");
            }
          );
        }
        else
        {
          Ext.Msg.alert("", Language.Application.Demo_EnterAllData);
        }
      }
    }
  ]

};