﻿/**********************************************************************
  SWITCH OVERVIEW: VIEW TEMPLATE
**********************************************************************/

var SwitchTpl_Overview = new Ext.XTemplate
(
  '<div class="CS_SwitchTpl_Overview">',
    '<div class="CS_SwitchTpl_Overview_DeviceDetails">',
      '<div class="CS_SwitchTpl_Overview_DeviceName">{deviceName} ({[this.getDeviceTypeDesc(values.deviceImpl)]})</div>',
      '<div class="CS_SwitchTpl_Overview_DeviceGroup">{[this.showGroupName(values.groupId)]}</div>',
    '</div>',
    '<div class="CS_SwitchTpl_Overview_LastResponse">',
      '<span class="CS_SwitchTpl_Overview_LastResponse_Title">{[this.translateText("Details_TS_LastStatus")]}</span>',
      '<span class="CS_SwitchTpl_Overview_LastResponse_Value">{[this.formatDate(values.lastResponse)]}</span>',
    '</div>',
    '<div class="CS_SwitchTpl_Overview_DeviceData">',
    '</div>',
  '</div>',
  {
    compiled: true,
    // TRANSLATE IN TEMPLATE
    translateText: function(input){
      return Language.Application[input];
    },
    showGroupName: function(groupId)
    {
      return GroupList.GetNameFromID(groupId);
    },
    getDeviceTypeDesc: function(ImplementationID)
    {
      return DeviceImplList.GetNameFromImpl(ImplementationID);
    },
    formatDate: function(date)
    {
      return formatDate(date);
    }
  }
);

/**********************************************************************
  SWITCH OVERALL: ACTION HANDLERS
**********************************************************************/

function SwitchOverallAction_SetTimer()
{

}

function SwitchOverallAction_QueryStatus()
{
  DeviceDetails.QueryActiveDeviceStatus();
}

/**********************************************************************
  SWITCH OVERALL: ACTIONS STORE
**********************************************************************/

var SwitchOverallActionsStore = new Ext.data.JsonStore(
{
  model: 'ActionsMenu',
  data: 
  [
    {id: 1, name: Language.Application.Details_SC_Overall_QueryStatus, action: 'SwitchOverallAction_QueryStatus'}
  ]
});

/**********************************************************************
  SWITCH OVERALL: CONTENT PANEL
**********************************************************************/

detailsSwitchOverall = 
{
  id: "ID_SwitchOverall",
  cls: "CS_SwitchOverall",

  scroll: 'vertical',
  xtype: 'panel',
  layout: 'fit',
  flex: 1,

  tpl: SwitchTpl_Overview
};

/**********************************************************************
  SWITCH OVERALL: CONTENT CONTAINER
**********************************************************************/

detailsSwitchOverallContainer = 
{
  id: "ID_SwitchOverallContainer",
  cls: "CS_SwitchOverallContainer",

  xtype: 'panel',
  layout:
  {
    type: 'vbox',
    pack: 'center',
    align: 'stretch'
  },

  LoadDetailsData: function(DetailsData)
  {  
    Ext.getCmp('ID_SwitchOverall').update(DetailsData);
    // assign the correct menu for actions button
    ActionsMenuTemplate.bindStore(SwitchOverallActionsStore);
    
    if (DetailsData.status === "pending")
    {
      Ext.getCmp('ID_BTN_SC_Overall_QueryStatus').disable(true);
    }
    else
    {
      Ext.getCmp('ID_BTN_SC_Overall_QueryStatus').enable(true);
    }
    
    // do layout
    this.doLayout();
    this.doComponentLayout();
  },

  items:
  [
    detailsSwitchOverall,
    {
      id: 'ID_BTN_SC_Overall_QueryStatus',
      cls: 'CS_BTN_ConfirmAction',
      dock: "bottom",
      xtype: "button",
      text: Language.Application.Details_SC_Overall_QueryStatus,
      cls: 'CS_BTN_ConfirmAction',
      ui: "confirm",
      handler: function()
      {
        SwitchOverallAction_QueryStatus();
      },
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',	
    }
    /*
    {
      id: 'ID_BTN_SC_Overall_SetTimer',
      cls: 'CS_BTN_ConfirmAction',
      dock:"bottom",
      xtype: "button",
      text: "Nastavi zakasnitev",
      cls: 'CS_BTN_ConfirmAction',
      id: 'ID_BTN_DV_SetTimer',
      ui: "confirm",
      handler: function()
      {
        SwitchOverallAction_SetTimer();
      },
      margin: "0px 8px 5px 5px",
      height: 45,
    },
    */
  ],
  
  setProfile: function (profile) 
  {  
    Ext.each
    (
      this.getDockedItems(), 
      function(item)
      {
        if (profile === "smallScreenHeight")
        {
          item.hide();
        }
        else
        {
          item.show();
        }
      }
    );
  }  
};

/**********************************************************************
  SWITCH TIMER: VIEW TEMPLATE
**********************************************************************/

var SwitchTpl_Timer = new Ext.XTemplate
(
  '<div class="CS_SwitchTpl_Timer">',
    '<div class="CS_SwitchTpl_Timer_DeviceDetails">',
      '<div class="CS_SwitchTpl_Timer_DeviceName">{deviceName}</div>',
      '<div class="CS_SwitchTpl_Timer_DeviceGroup">{[this.showGroupName(values.groupId)]}</div>',
    '</div>',
  '</div>',
  {
    compiled: true,
    // TRANSLATE IN TEMPLATE
    showGroupName: function(groupId)
    {
      return GroupList.GetNameFromID(groupId);
    },
  }
);

/**********************************************************************
  SWITCH TIMER: TIME PICKER
**********************************************************************/

var detailsSwitchTimer_TimePicker = new Ext.ux.form.TimePicker(
{
  name : 'duration',
  label: 'Trajanje',
  minuteScale: 10,
  picker:
  {
    hourFrom: 0,
    hourTo: 12,
  }
});

/**********************************************************************
  SWITCH TIMER: ACTION HANDLERS
**********************************************************************/

function SwitchTimerAction_SetTimer()
{
  /*
  var time = hourPickerField.getValue();
  var date = datePickerField.getValue(true);
  var duration = durationPickerField.getValue();
  
  demo_setTimer(demo_timer_header.data.id, date, time, duration);
  demo_showSocketScreen(demo_timer_header);
  
  hourPickerField.reset();
  datePickerField.reset();
  durationPickerField.reset();
  */
}

function SwitchTimerAction_TurnOff()
{
  /*
  hourPickerField.reset();
  datePickerField.reset();
  durationPickerField.reset();
  
  demo_setTimer(demo_timer_header.data.id, null, null, null);
  demo_showSocketScreen(demo_timer_header);
  */
}

/**********************************************************************
  SWITCH TIMER: ACTIONS STORE
**********************************************************************/

var SwitchTimerActionsStore = new Ext.data.JsonStore(
{
  model: 'ActionsMenu',
  data: 
  [
    {id: 1, name: Language.Application.Details_SC_Timer_SetTimer, action: 'SwitchTimerAction_SetTimer'},
    {id: 2, name: Language.Application.Details_SC_Timer_CancelTimer, action: 'SwitchTimerAction_TurnOff'}
  ]
});

/**********************************************************************
  SWITCH TIMER: CONTENT PANEL
**********************************************************************/

detailsSwitchTimer = 
{
  id: "ID_SwitchTimer",
  cls: "CS_SwitchTimer",

  scroll: 'vertical',
  margin: "6px",
  xtype: 'panel',
  
  items:
  [
    {
      id: "ID_SwitchTimer_Header",
      cls: "CS_SwitchTimer_Header",
      tpl: SwitchTpl_Timer,
      xtype: 'panel'
    },
    {
      id: "ID_SwitchTimer_Form",
      cls: "CS_SwitchTimer_Form",
      xtype: 'formpanel',
      items:
      [
        {
          xtype: 'fieldset',
          items:
          [
            {
              xtype:'selectfield',
              name : 'timer_on_off',
              label: Language.Application.Details_SC_Timer_OnOff,
              labelWidth: "50%",
              options : 
              [
                {text: Language.Application.Details_SC_Timer_On, value: "turnOn"},
                {text: Language.Application.Details_SC_Timer_Off, value: "turnOff"},
              ]
            },
            detailsSwitchTimer_TimePicker
          ]
        }
      ]
    }
  ]
};

/**********************************************************************
  SWITCH TIMER: CONTENT CONTAINER
**********************************************************************/

detailsSwitchTimerContainer = 
{
  id: "ID_SwitchTimerContainer",
  cls: "CS_SwitchTimerContainer",
  scroll: 'vertical',
  xtype: 'panel',
  layout: "fit",
  
  items:
  [
    detailsSwitchTimer
  ],
  
  LoadDetailsData: function(DetailsData)
  {  
    Ext.getCmp('ID_SwitchTimer_Header').update(DetailsData);
    // assign the correct menu for actions button
    ActionsMenuTemplate.bindStore(SwitchTimerActionsStore);
  },

  setProfile: function (profile) 
  {
    Ext.each
    (
      this.getDockedItems(), 
      function(item)
      {
        if (profile === "smallScreenHeight")
        {
          item.hide();
        }
        else
        {
          item.show();
        }
      }
    );
  },

  dockedItems:
  [
    {
      id: 'ID_BTN_SC_Timer_CancelTimer',
      cls: 'CS_BTN_DeleteAction',
      dock: "bottom",
      xtype: "button",
      text: Language.Application.Details_SC_Timer_CancelTimer,
      ui: "decline",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',	
      handler: function()
      {

      }
    },
    {
      id: 'ID_BTN_SC_Timer_SetTimer',
      cls: 'CS_BTN_ConfirmAction',
      dock: "bottom",
      xtype: "button",
      text: Language.Application.Details_SC_Timer_SetTimer,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',	
      handler: function()
      {

      }
    }
  ]
};
