﻿var OperationalStatuses = ["OK", "pending", "noResponse", "failed", "unknown"];

var DetailStates =
{
  states:
  {
    "switch" : 1,
    "thermalSwitch" : 2,
    "thermalSwitch_Temp" : 3,
    "thermalSwitch_Timer" : 4,
    "captureCamera" : 5,
    "switchSensorPower" : 6,
    "motionSensor" : 7,
    "sensor" : 8  
  },
  getState: function(registered, type)
  {  
    if (registered)
    {
      return this.states[type];
    }
    else 
    {
      return 0;
    }
  }
};
 
var detailsStateHistory = [];
var detailsCurrentState = -1;

function setDetailsNextState(State)
{
  detailsStateHistory.push(detailsCurrentState);
  detailsCurrentState = State;  
}

function DoSetDetailsNextState(State)
{
  setDetailsNextState(State);
  Ext.getCmp('ID_DeviceDetails_Panel').setActiveItem(State);
  DeviceDetails.SetActivePanel(Ext.getCmp('ID_DeviceDetails_Panel').getActiveItem());
}

function SetDetailsPreviousState()
{
  if (detailsStateHistory.length > 0)
  {
    detailsCurrentState = detailsStateHistory.pop();
    return detailsCurrentState;
  }
  else
  {
    return -1;
  }
}

function DetailsBackButtonClick()
{
  var PreviousState = SetDetailsPreviousState();
  
  if (PreviousState > -1)
  {
    Ext.getCmp('ID_DeviceDetails_Panel').setActiveItem(PreviousState);
    DeviceDetails.SetActivePanel(Ext.getCmp('ID_DeviceDetails_Panel').getActiveItem());
  }
  else
  {
    MainPanel.setActiveItem(SetAppPreviousState());    
    DeviceDetails.ResetActiveRecord();
  }
}

var DeviceDetails = (function()
{
  var ActiveDetails = null;
  var ActiveRecord = null;
  var ActivePanel = null;
  var PrgIndc = null;

  /*class constructor.*/
  function Initialize()
  {
    var self = this;
  }

  function RemovePrgIndc()
  {
    if (PrgIndc !== null)
    {
      DeleteProgressIndicator(PrgIndc);
      PrgIndc = null;
    }
  }

  RefreshRecordState = function(DeviceDetails)
  {
    if (ActiveRecord !== null)
    {      
      if (ActiveRecord.get("deviceId").toString() === DeviceDetails.deviceId.toString())
      {
        ActivePanel.LoadDetailsData(DeviceDetails);
        
        if (DeviceDetails.status === "pending")
        {
          if (PrgIndc === null)
          {
            PrgIndc = SetProgressIndicator(document.getElementById('ID_spinnerContainer'), 0, '#FFFFFF');
          }
        }
        else
        {
          RemovePrgIndc();
        }
      }
    }
  }

  Initialize.QueryActiveDeviceStatus = function()
  {
    MainPanel.setLoading(true, true);
    DeviceList.QueryDeviceStatus
    (
      ActiveRecord.get('deviceId'),
      
      function OnSuccess(Response)
      {
        ActiveDetails = Response.data[0];
        MainPanel.setLoading(false);
        
        if (ActiveDetails.status === "pending")
        {
          PeriodicallyCheckDevice(ActiveDetails.deviceId, ActiveDetails.estimatedReponseTime, 1);
        }
      },
      
      function OnFailure(Response)
      {
        MainPanel.setLoading(false); 

        if (LoggedUser.LoggedIn())
        { 
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Common_Error_General);
        }
      }
    );
  };

  Initialize.GetDeviceDetails = function(DeviceRecord)
  {
    detailsCurrentState = DetailStates.getState(DeviceRecord.get('registered'), DeviceRecord.get('type'));    
    Ext.getCmp('ID_DeviceDetails_Panel').setActiveItem(detailsCurrentState);
    ActivePanel = Ext.getCmp('ID_DeviceDetails_Panel').getActiveItem();
    ActiveRecord = DeviceRecord;

    // set the loading indicator
    MainPanel.setLoading(true, true);

    API.Call
    (
      'getDeviceDetails',
      {
        deviceIds: [DeviceRecord.get('deviceId')]
      },
      function(Response)
      {
        ActiveDetails = Response.data[0];        
        MainPanel.setLoading(false);
      },
      function(Response)
      {
        MainPanel.setLoading(false);
        
        if (LoggedUser.LoggedIn())
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Common_Error_General);
        }
      },
      function(Response)
      {
        MainPanel.setLoading(false);
      }
    );
  };

  Initialize.OnAPICallEvent = function(apiName, response, success)
  {
    // do we need to update devices
    if ((DeviceDetailsAPIs.indexOf(apiName) > -1) && (success))
    {
      ActiveDetails = response.data[0];
      RefreshRecordState(ActiveDetails);
    }  
  };

  Initialize.SetActivePanel = function(NewActivePanel)
  {
    ActivePanel = NewActivePanel;
    ActivePanel.LoadDetailsData(ActiveDetails);
  };
  
  Initialize.ResetActiveRecord = function()
  {
    ActiveRecord = null;
    ActivePanel = null;
  };

  Initialize.GetActiveDetails = function()
  {
    return ActiveDetails;
  };

  Initialize.GetActiveRecord = function()
  {
    return ActiveRecord;
  };

  return Initialize;
})();

var ActionsMenuTemplate = new Ext.DataView(
{
    tpl: 
    [
      '<tpl for=".">',
        '<div class="x-list-item" action="{action}">',
          '<div class="x-list-item-body">{name}</div>',
        '</div>',
      '</tpl>'
    ],
    cls: "x-list",
    itemSelector: ".x-list-item",
    allowDeselect: false,
    singleSelect: true,
    store: null,
    listeners: 
    {
      itemtap: function(view, index, item, e)
      {
        var action = Ext.get(item).getAttribute("action");
        var fn = window[action];
        ActionsMenu.hide();
        
        if(typeof fn === 'function') 
        {
          fn();
        }
      }
    }
});

// a wrapper around the menu list
var ActionsMenu = new Ext.Panel(
{
  width: 150,
  height: 200,
  dock: 'left',
  layout: 'fit',
  floating: true,
  items: [ActionsMenuTemplate]
});

DetailsPanel =
{
  id: 'ID_Details_Panel',
  cls: 'CS_Details_Panel',
  xtype: 'panel',
  layout:
  {
    type: 'vbox',
    pack: 'center',
    align: 'stretch'
  },

  setProfile: function(profile) 
  {
    if (profile === "smallScreenHeight") 
    {
      Ext.getCmp('ID_Actions_Button').show();
      Ext.getCmp('ID_Details_Panel').doLayout();
      Ext.getCmp('ID_Details_Panel').doComponentLayout();
    }
    else 
    {
      Ext.getCmp('ID_Actions_Button').hide();
      Ext.getCmp('ID_Details_Panel').doLayout();
      Ext.getCmp('ID_Details_Panel').doComponentLayout();
    }
  },
  
  items:
  [
    {
      cls: 'CS_Navigation_Menu',
      //padding: "0px 5px 0px 5px",
      xtype: 'panel',
	  height: 77,
      layout:
      {
        type: 'hbox',
      },
      items:
      [
        {
          cls: 'CS_Back_Container',
          height: 60,
          flex: 1,
          layout:
          {
            type: 'hbox',
            pack: 'left'
          },
          items:
          [
            {
              cls: 'CS_Back_Button',
              xtype: 'BackButton',
              text: Language.Application.Common_Bnt_Back,
              handler: function()
              {
                DetailsBackButtonClick();
              }
            }
          ]
        },
        {
          cls: "detailsStateTitleContainer",
          html: '<div class="detailsStateTitle"><p>' + Language.Application.Details_Title +'</p></div>',
          height: 60,
          flex: 2
        },
        {
          height: 60,
          flex: 1,
          layout:
          {
            type: 'hbox',
            pack: 'right'
          },
          items:
          [
            {
              id: 'ID_spinnerContainer',
              cls: 'CS_spinnerContainer',
              html: '<div class="CS_spinnerContainerDiv" />',
              height: '40',
              width: '40'
            },
            {
              width: 36,
              height: 36,
              hidden: true,
              xtype: 'button',
              id: "ID_Actions_Button",
              cls: "CS_Actions_Button",
              handler: function()
              {
                ActionsMenu.showBy(this);
              }
            }          
          ]
        },
      ]
    },
    {
      id: 'ID_DeviceDetails_Panel',
      cls: 'CS_DeviceDetails_Panel',
      padding: "10px 5px 5px 5px",
      layout: 'card',
      flex: 1,
      items:
      [
        detailsRegisterOverallContainer,
        detailsSwitchOverallContainer,
        detailsThermalSwitchOverallContainer,
        detailsThermalSwitchTempContainer,
        detailsThermalSwitchTimerContainer,
        detailsCaptureCameraOverallContainer,
        detailsSwitchSensorPower,
        detailsMotionSensor,
        detailsSensor
      ]
    }
  ]
};

// add API listener for the device list
API.AddRemoteListener(DeviceDetails.OnAPICallEvent);