﻿var RegisterDeviceImplDataStore = new Ext.data.Store(
{
  model: 'DeviceImpl',
  filterOnLoad: true,

  proxy:
  {
    type: 'memory'
  },

  filters:
  [
    {
      property: 'hiddenForRegistration',
      value: false
    }
  ]
});

var UnusedMISISDNStore = new Ext.data.Store(
{
  model: 'UnusedMISISDN',

  proxy:
  {
    type: 'memory'
  }
});

var AddDeviceTypeAndGroup = (function()
{
  var DeviceGroup = null;
  var DeviceImpl = null;

  /*class constructor.*/
  function Initialize()
  {
    var self = this;
  }

  Initialize.LoadDeviceData = function(onFinished)
  {
    CallGetGroupInfo
    (
      function OnFinished(success)
      {
        if (success)
        {
          CallDeviceImplInfo
          (
            function OnFinished(success)
            {
              if (success)
              {
                RegisterDeviceImplDataStore.loadData(DeviceImplDataStore.getRange());
                API.Call
                (
                  "getAccountData",
                  {
                    // no parameters
                  },
                  function(Response)
                  {
                    UnusedMISISDNStore.loadData([]);
                    
                    for (var i = 0; i < Response.data.unregisteredDeviceMsisdns.length; i++)
                    {
                      UnusedMISISDNStore.add({number: Response.data.unregisteredDeviceMsisdns[i]});
                    }

                    if (GroupDataStore.getCount() === 0)
                    {
                      Ext.getCmp('ID_deviceGroup_dropdown').setValue(null);
                      Ext.getCmp('ID_deviceGroup_dropdown').disable();
                    }
                    else
                    {
                      Ext.getCmp('ID_deviceGroup_dropdown').setValue(GroupDataStore.getAt(0).get('id'));
                      Ext.getCmp('ID_deviceGroup_dropdown').enable();
                    }

                    if (RegisterDeviceImplDataStore.getCount() === 0)
                    {
                      Ext.getCmp('ID_deviceType_dropdown').setValue(null);
                      Ext.getCmp('ID_BTN_AddDeviceType_Submit').disable();
                      Ext.getCmp('ID_deviceType_dropdown').disable();
                    }
                    else
                    {
                      Ext.getCmp('ID_deviceType_dropdown').setValue(RegisterDeviceImplDataStore.getAt(0).get('deviceImpl'));
                      Ext.getCmp('ID_BTN_AddDeviceType_Submit').enable();
                      Ext.getCmp('ID_deviceType_dropdown').enable();
                    }

                    onFinished(true);
                  },
                  function(Response)
                  {
                    // notify failure
                    onFinished(false);
                  }
                );
              }
              else
              {
                onFinished(false);
              }
           }
          );
        }
        else
        {
          onFinished(false);
        }
      }
    );  
  };

  Initialize.GetDeviceGroup = function()
  {
    return DeviceGroup;
  };

  Initialize.GetDeviceImpl = function()
  {
    return DeviceImpl;
  };

  Initialize.SetDeviceGroup = function(value)
  {
    DeviceGroup = value;
  };

  Initialize.SetDeviceImpl = function(value)
  {
    DeviceImpl = value;
  };

  return Initialize;
})();