﻿var EditeDeviceNameAndGroup = (function()
{
  var DeviceId = null;

  /*class constructor.*/
  function Initialize()
  {
    var self = this;
  }

  Initialize.GetDeviceId = function()
  {
    return DeviceId;
  };

  Initialize.SetDeviceId = function(value)
  {
    DeviceId = value;
  };

  return Initialize;
})();

var EditDeviceListItemTpl = new Ext.XTemplate
(
  '<table class="CS_Devices_Wrapper" device_id="{deviceId}">',
    '<tr>',
      '<td class="CS_Devices_Image {[this.getDeviceTypeImageClass(values.type)]}">',
        '<img src="{[this.getDeviceTypeImage(values.type)]}">',
      '</td>',
      '<td class="CS_Devices_Data">',
        '<div class="CS_Devices_Name">{deviceName}</div>',
      '</td>',
      '<td class="CS_EditDevice_Spacer"></td>',
      '<td class="CS_EditDevice_Cell">',
        '<div class="CS_EditDevice_Wrapper">',
          '<img class="CS_EditDevice_Image" src="images/settings.png">',
        '</div>',
      '</td>',
    '</tr>',
  '</table>',
  {
    compiled: true,
        
    getDeviceTypeImage: function(deviceType)
    {
      return TypeImages.getType(deviceType).image;
    },
    getDeviceTypeImageClass: function(deviceType)
    {
      return TypeImages.getType(deviceType).cls;
    }
  }
);

EditDeviceList =
{
  id: 'ID_EditDeviceList',
  cls: 'CS_EditDevice_List',
  itemCls: 'CS_EditDeviceItem',
  selectedItemCls: 'CS_EditDeviceItem_Selected',

  itemTpl: EditDeviceListItemTpl,
  pinHeaders: false,
  xtype: 'list',
  
  listeners:
  {
    itemtap: function (view, index, item, e)
    {
       var itemElement = getElementsByClass("CS_Devices_Wrapper", item, 'table')[0];
       var Record = DeviceDataStore.findRecord("deviceId", itemElement.getAttribute("device_id"));
       
       if (Record !== null)
       {
          DoSelectSettingsState(SettingsStates.EditDeviceForm, 'ID_EditDeviceForm', true);
          EditeDeviceNameAndGroup.SetDeviceId(Record.get("deviceId"));
          Ext.getCmp('ID_EditDeviceForm').InitializeRecord(Record);
       }

    }
  },
  selModel:
  {
    mode: 'SINGLE',
    allowDeselect: true
  },
  grouped: true,
  store: DeviceDataStore
};

EditDeviceForm =
{
  id: 'ID_EditDeviceForm',
  cls: 'CS_EditDeviceForm',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,

  InitializeRecord: function(Record)
  {
    Ext.getCmp('ID_EditDeviceForm').setValues(
    {
      deviceName: Record.get("deviceName"),
      groupName: Record.get("groupId")
    });
  },

  items:
  [
    {
      cls: 'CS_Fieldset_EditDevice',
      xtype: "fieldset",
      title: Language.Application.EditDevice_Name,
      items:
      [
        {
          name: "deviceName",
          xtype: "textfield"
        }
      ]
    },
    {
      xtype: "fieldset",
      title: Language.Application.EditDevice_Room,
      items:
      [
        {
          name: "groupName",
          xtype: "selectfield",
          store: GroupDataStore,
          displayField:'name',
          valueField:'id'
        }
      ]
    },
    {
      xtype: "fieldset",
      items:
      [
        {
        name: "deviceId",
        xtype: "textfield",
        hidden: true
        }
      ]
    }
  ],
  
  dockedItems:
  [
    {
      id: 'ID_BTN_EditDevice_Delete',
      cls: 'CS_BTN_DeleteAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.EditDevice_Delete,
      ui: "decline",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',
      handler: function()
      {        
        if (EditeDeviceNameAndGroup.GetDeviceId() !== "")
        {
          Ext.getCmp('ID_BTN_EditDevice_Delete').disable(true);
          MainPanel.setLoading(true, true);
          API.Call
          (
            'deleteDevice',
            [
              EditeDeviceNameAndGroup.GetDeviceId()
            ],
            function(Response)
            {
              if (Response.status === "OK") 
              {
                DeviceDataStore.remove(DeviceDataStore.findRecord("deviceId", EditeDeviceNameAndGroup.GetDeviceId()));
                DeviceDataStore.sync();

                Ext.getCmp('ID_BTN_EditDevice_Delete').enable(true);
                MainPanel.setLoading(false);

                Ext.Msg.alert
                (
                  Language.Application.Common_Info,
                  Language.Application.EditDevice_DeleteDeviceSuccess,
                  function()
                  {
                    SettingsBackButtonClick();
                  }
                );
              }
              else
              {
                MainPanel.setLoading(false);
                Ext.getCmp('ID_BTN_EditDevice_Delete').enable(true);
                Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditDevice_DeleteDeviceError);
              }
            },
            function(Response)
            {
              MainPanel.setLoading(false);
              Ext.getCmp('ID_BTN_EditDevice_Delete').enable(true);
              Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditDevice_DeleteDeviceError);
            },
            function(Response)
            {
              Ext.getCmp('ID_BTN_EditDevice_Delete').enable(true);
            }
          );
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditDevice_NoDeviceID);
        }
      }
    },
    {
      id: 'ID_BTN_EditDevice_Submit',
      cls: 'CS_BTN_ConfirmAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.EditDevice_Submit,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',
      handler: function()
      {
        var values = Ext.getCmp('ID_EditDeviceForm').getValues();

        if (!!values.deviceName && !!values.groupName)
        {         
          function SignalSuccess(DeviceDetails)
          {
            DeviceList.UpdateDeviceData(DeviceDetails);

            Ext.getCmp('ID_BTN_EditDevice_Submit').enable(true);
            MainPanel.setLoading(false);
            
            Ext.Msg.alert
            (
              Language.Application.Common_Info,
              Language.Application.EditDevice_EditDeviceSuccess,
              function()
              {
                Ext.getCmp('ID_EditDeviceForm').reset();
                SettingsBackButtonClick();
              }
            );
          }

          Ext.getCmp('ID_BTN_EditDevice_Submit').disable(true);
          MainPanel.setLoading(true, true);
          
          API.Call
          (
            'updateDevice',
            {
              deviceId: EditeDeviceNameAndGroup.GetDeviceId(),
              deviceName: values.deviceName
            },
            function(responseDetails)
            {
              API.Call
              (
                'updateDeviceGroup',
                [
                  {
                    deviceId: responseDetails.data.deviceId,
                    groupId: values.groupName
                  }
                ],
                function(responseUpdateGroup)
                {
                  responseDetails.data.groupId = values.groupName;
                  SignalSuccess(responseDetails.data);
                },
                function(responseUpdateGroup)
                {
                  Ext.getCmp('ID_BTN_EditDevice_Submit').enable(true);
                  MainPanel.setLoading(false);                  
                  
                  Ext.Msg.alert
                  (
                    Language.Application.Common_Error,
                    Language.Application.EditDevice_UpdateGroupError,
                    function()
                    {
                      Ext.getCmp('ID_EditDeviceForm').reset();
                    }
                  );
                },
                function(responseUpdateGroup)
                {
                  Ext.getCmp('ID_BTN_EditDevice_Submit').enable(true);
                }
              );
            },
            function(responseDetails)
            {
              Ext.getCmp('ID_BTN_EditDevice_Submit').enable(true);
              MainPanel.setLoading(false);  
              
              Ext.Msg.alert
              (
                Language.Application.Common_Error,
                Language.Application.EditDevice_EditDeviceError,
                function()
                {
                  Ext.getCmp('ID_EditDeviceForm').reset();
                }
              );
            },
            function(responseDetails)
            {
              Ext.getCmp('ID_BTN_EditDevice_Submit').enable(true);
            }
          );
        }
      }
    }
  ]
};