﻿EditGroupList = 
{
  id: 'ID_EditGroupList',
  cls: 'CS_EditGroupList',
  itemCls: 'CS_EditGroupListItem',
  selectedItemCls: 'CS_EditGroupListItem_Selected',
  tpl:
  [
    '<div id="ID_EditGroup_List">',
      '<tpl for=".">',
        '<div class="CS_Groups_Wrapper CS_EditGroups_Wrapper">',
          '<div class="CS_Group_Desc CS_EditGroup_Desc">{name}</div>',
          '<div class="CS_Group_arrow CS_EditGroup_arrow"><img src="library/SenchaTouch/resources/themes/images/default/pictos/settings1.png"/></div>',
        '</div>',
      '</tpl>',
    '</div>'
  ],
  padding: "0px 5px 0px 5px",
  xtype: 'dataview',
  flex: 1,
  selModel:
  {
    mode: 'SINGLE',
    allowDeselect: true
  },
  itemSelector:'div.CS_Groups_Wrapper',
  store: GroupDataStore,
  listeners:
  {
    itemtap: function (view, index, item, e)
    {
      Ext.getCmp('ID_EditGroupForm').InitializeRecord(Ext.getCmp('ID_EditGroupList').getRecord(item));
      DoSelectSettingsState(SettingsStates.EditGroupForm, 'ID_EditGroupForm', true);
    }
  }
};

EditGroupForm =
{
  id: 'ID_EditGroupForm',
  cls: 'CS_EditGroupForm',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,

  InitializeRecord: function(record)
  {
    Ext.getCmp('ID_EditGroupForm').setValues(
    {
      name: record.get("name"),
      id: record.get("id")
    });
  },

  items:
  [
    {
      cls: 'CS_Fieldset_EditGroup',
      xtype: "fieldset",
      title: Language.Application.EditGroup_Name,
      items:
      [
        {
          name: "name",
          xtype: "textfield"
        }
      ]
    },
    {
      xtype: "fieldset",
      instructions: '',
      items:
      [
        {
        name: "id",
        xtype: "textfield",
        hidden: true
        }
      ]
    }
  ],
  
  dockedItems:
  [
    {
      id: 'ID_BTN_EditGroup_Delete',
      cls: 'CS_BTN_DeleteAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.EditGroup_Delete,
      ui: "decline",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',
      handler: function()
      {
        var values = Ext.getCmp('ID_EditGroupForm').getValues();

        if(!!values.id)
        {
          Ext.getCmp('ID_BTN_EditGroup_Delete').disable(true);
          MainPanel.setLoading(true, true);
          API.Call
          (
            'deleteGroup',
            [
              values.id
            ],
            function(Response)
            {
              if (Response.status === "OK") 
              {
                GroupDataStore.remove(GroupDataStore.findRecord("id", values.id));
                FilteredDeviceList.Clear();
                DeviceList.Clear();
    
                // call GetDeviceInfo again
                CallGetDeviceInfo(function(success) {});

                Ext.getCmp('ID_BTN_EditGroup_Delete').enable(true);
                MainPanel.setLoading(false);

                Ext.Msg.alert
                (
                  Language.Application.Common_Info,
                  Language.Application.EditGroup_DeleteGroupSuccess,
                  function()
                  {
                    SettingsBackButtonClick();
                  }
                );
              }
              else
              {
                MainPanel.setLoading(false);
                Ext.getCmp('ID_BTN_EditGroup_Delete').enable(true);
                Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditGroup_DeleteGroupError);
              }
            },
            function(Response)
            {
              MainPanel.setLoading(false);
              Ext.getCmp('ID_BTN_EditGroup_Delete').enable(true);
              Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditGroup_DeleteGroupError);
            },
            function(Response)
            {
              Ext.getCmp('ID_BTN_EditGroup_Delete').enable(true);            
            }
          );
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditGroup_NoGroupID);
        }
      }
    },
    {
      id: 'ID_BTN_EditGroup_Submit',
      cls: 'CS_BTN_ConfirmAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.EditGroup_Submit,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',
      handler: function()
      {
        var values = Ext.getCmp('ID_EditGroupForm').getValues();

        if(!!values.name)
        {
          Ext.getCmp('ID_BTN_EditGroup_Submit').disable(true);
          MainPanel.setLoading(true, true);
          
          API.Call
          (
            'updateGroup',
            [
              {
                id: values.id,
                name: values.name
              }
            ],
            function(Response)
            {
              GroupDataStore.findRecord("id", Response.data[0].id).set("name", Response.data[0].name);
              
              Ext.getCmp('ID_BTN_EditGroup_Submit').enable(true);
              MainPanel.setLoading(false);
              
              Ext.Msg.alert
              (
                Language.Application.Common_Info,
                Language.Application.EditGroup_EditGroupSuccess,
                function()
                {
                  SettingsBackButtonClick();
                }
              );
            },
            function(Response)
            {
              Ext.getCmp('ID_BTN_EditGroup_Submit').enable(true);
              MainPanel.setLoading(false);
              
              Ext.Msg.alert
              (
                Language.Application.Common_Error,
                Language.Application.EditGroup_EditGroupError,
                function()
                {
                  Ext.getCmp('ID_EditGroupForm').reset();
                }
              );
            },
            function(Response)
            {
              Ext.getCmp('ID_BTN_EditGroup_Submit').enable(true);            
            }
          );
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.EditGroup_EnterGroupName);
        }
      }
    }
  ]
};