﻿var GroupDataStore = new Ext.data.Store(
{
  model: 'Group',
  filterOnLoad: false,

  proxy:
  {
    type: 'memory'
  },
});

var GroupList = (function()
{
  var FetchedRecords = false;
  var DataBuffer = null;

  /*class constructor.*/
  function Initialize()
  {
    var self = this;
  }
    
  Initialize.GetGroupInfo = function(OnSuccessCallback, OnFailureCallback)
  {
    if (FetchedRecords === false)
    {
      API.Call
      (
        "getGroupInfo",
        {
          // no data is sent
        },
        function(Response)
        {
          //decode json string
          DataBuffer = Response;           
          // we have all data
          FetchedRecords = true;
          // notify sucess
          OnSuccessCallback();
        },
        function(Response)
        {
          // notify failure
          OnFailureCallback();
        },
        function(Response)
        {
          // notify failure
          OnFailureCallback();
        }
      );
    }
  };

  Initialize.GetNameFromID = function(ID)
  {
    // return the name of the record found by ID
    var Record = GroupDataStore.findRecord('id', ID);
    
    if (Record !== null)  
    {
      return Record.get('name');
    }
    else
    {
      return Language.Application.Groups_Undefined;
    }  
  };

  Initialize.Items = function()
  {
    return DataBuffer.data;
  };

  Initialize.IsInitialized = function()
  {
    return FetchedRecords;
  };

  Initialize.Clear = function()
  {
    GroupDataStore.clearFilter();
    GroupDataStore.loadData([]);    
    FetchedRecords = false;
  };

  return Initialize;
})();

function CallFilteredGroupList(Group)
{
  CallGetGroupInfo
  (
    function(success)
    {
      if (GroupDataStore.isFiltered() === true)  
      {
        // first clear all the filters
        GroupDataStore.clearFilter(false);
      }

      // set appropriate filters
      if (Group !== null) 
      {
        GroupDataStore.filter("name", Group);
      }
    }
  );  
}

function CallGetGroupInfo(OnFinished)
{
  if (GroupList.IsInitialized() === false) 
  {
    MainPanel.setLoading(true, true);
    GroupDataStore.loadData([]);

    GroupList.GetGroupInfo
    (
      function()
      {
        MainPanel.setLoading(false);

        GroupDataStore.loadData(GroupList.Items());
        OnFinished(true);
      },
      function()
      {
        MainPanel.setLoading(false);
        OnFinished(false);
        
        if (LoggedUser.LoggedIn())
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Common_Error_General);
        }
      }
    );
  }
  else
  {
    OnFinished(true);
  }
}

GroupPanel =
{
  id: 'ID_Group_Panel',
  cls: 'CS_Group_Panel',
  xtype: 'panel',
  layout:
  {
    type: 'vbox',
    pack: 'center',
    align: 'stretch'
  },

  items:
  [
    {
      title: Language.Application.Groups_AllGroups,
      xtype: 'BackNavigation',

      handler: function()
      {
        MainPanel.setActiveItem(SetAppPreviousState());
      }
    },
    {
      id: 'ID_GroupList',
      cls: 'CS_Group_List',      
      itemCls: 'CS_GroupItem',
      selectedItemCls: 'CS_GroupItem_Selected',
		  style: {
            backgroundImage: 'url(../images/wrapper_bg.png)',
            backgroundRepeat: 'repeat-x',
            backgroundPosition: 'top left',
			backgroundColor: '#0f1111'
		  },	  
      tpl:
      [
        '<div id="ID_Group_List">',
          '<tpl for=".">',
            '<div class="CS_Groups_Wrapper">',
              '<div class="CS_Group_Desc">{name}</div>',
              '<div class="CS_Group_arrow"><img src="images/btn_arrow.png"/></div>',
            '</div>',
          '</tpl>',
        '</div>'
      ],
      padding: "0px 5px 0px 5px",
      xtype: 'dataview',
      flex: 1,
      selModel:
      {
        mode: 'SINGLE',
        allowDeselect: true
      },
      itemSelector:'div.CS_Groups_Wrapper',
      store: GroupDataStore,
      listeners:
      {
        itemtap: function (view, index, item, e)
        {
          setAppNextState(ApplicationStates.Devices);
          MainPanel.setActiveItem(ApplicationStates.Devices);
          Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Devices_Devices);
          FilteredDeviceList.Get(null, Ext.getCmp('ID_GroupList').getRecord(item).get('id'));
        }
      }
    }
  ]
};

