﻿var ResourceList = 
[
  'library/SenchaTouch/resources/css/sencha-touch.css',
  'style/DetailStates/Details_ThermalSwitch.css',
  'style/DetailStates/Details_CaptureCamera.css',
  'style/DetailStates/Details_Register.css',
  'style/DetailStates/Details_Switch.css',
  'style/Authenticate.css',
  'style/MiscSettings.css',
  'style/DemoRegister.css',
  'style/AppSettings.css',
  'style/EditDevice.css',
  'style/EditGroup.css',
  'style/AddDevice.css',
  'style/AddGroup.css',
  'style/MainMenu.css',
  'style/Startup.css',
  'style/Details.css',
  'style/Devices.css',
  'style/Groups.css',
  'style/Common.css',
  'style/Custom.css',

  'library/TimePicker/form/TimePicker.js',
  'library/TimePicker/TimePicker.js', 
  'library/HashTable/hashTable.js',
  'library/BusyJS/cvi_busy_lib.js',
  'library/sprintf/sprintf.js',
  'library/DateJS/date.js',

  'scripts/Templates.js',
  'scripts/Storage.js',
  'scripts/API.js',
  
  'demodata/scripts/API_ThermalSwitch.js',
  'demodata/scripts/API_CaptureCamera.js',
  'demodata/scripts/API_Switch.js',
  'demodata/scripts/DemoData.js',

  'scripts/Common.js',
  'scripts/Groups.js',
  'scripts/Devices.js',
  'scripts/DemoRegister.js',
  'scripts/Authenticate.js',
  'scripts/AddGroup.js',
  'scripts/EditDevice.js',
  'scripts/EditGroup.js',
  'scripts/MiscSettings.js',

  'scripts/DetailStates/Details_Switch.js',
  'scripts/DetailStates/Details_Register.js',
  'scripts/DetailStates/Details_ThermalSwitch.js',
  'scripts/DetailStates/Details_MotionSensor.js',
  'scripts/DetailStates/Details_CaptureCamera.js',
  'scripts/DetailStates/Details_SwitchSensorPower.js',
  'scripts/DetailStates/Details_Sensor.js',
  'scripts/Details.js',

  'scripts/DeviceTypes.js',
  'scripts/Registrations/AddDeviceCaptureCamera.js',
  'scripts/Registrations/AddDeviceTutaS30Socket.js',
  'scripts/Registrations/AddDeviceStripsSocket.js',
  'scripts/Registrations/AddDeviceSmartehGM2.js',
  'scripts/AddDevice.js',
  
  'scripts/AppSettings.js',
  'scripts/Overrides.js',
  'scripts/MainMenu.js',
  'scripts/Startup.js'
];

function IncreaseProgressAndCallNext(fileList, onLoadDone, index)
{
  document.getElementById("ID_Progress_Value").style.width = Math.round(((index + 1) / fileList.length) * 100) + "%";
  LoadScriptBundle(fileList, onLoadDone, index + 1); 
}

function LoadScriptBundle(fileList, onLoadDone, index)
{
  index = typeof index !== 'undefined' ? index: 0;
  
  if (index === fileList.length)
  {
    onLoadDone(true);
  }
  else
  {
    var fileExt = fileList[index].split('.').pop();
    
    if (fileExt === "js")
    {
      LazyLoad.js(fileList[index], function () 
      {
        IncreaseProgressAndCallNext(fileList, onLoadDone, index);
      }); 
    }
    else if (fileExt === "css")
    {
      LazyLoad.css(fileList[index], function () 
      {
        IncreaseProgressAndCallNext(fileList, onLoadDone, index);
      });     
    }
  }
}

function finishProgressBar()
{
  document.getElementById("ID_Progress_Text").innerHTML = Language.Application.Common_StartingApp;
}

function LoadApplicationModules()
{
  LoadScriptBundle
  (
    ResourceList,
    function onLoadDone(success) 
    { 
      finishProgressBar();
    }
  );
}

function InitializeApplication()
{  
  // initialize application
  mainSettings.LoadSettings();  
  
  if (mainSettings.GetIsFixNeeded())
  {
    ResourceList.push('style/Android.css');
  }

  LazyLoad.js('languages/' + mainSettings.GetLanguage() + '.js', function () 
  {
    document.getElementById("ID_Progress_Text").innerHTML = Language.Application.Common_LoadingApp;
    LoadApplicationModules();
  }); 
}
