﻿// hide the main progress bar
Ext.get("ID_Progress_Bar").hide();
Ext.get("ID_Progress_Text").hide();

Ext.regApplication(
{
  name: 'MyHome',
  launch: function()
  {
    this.launched = true;
    this.mainLaunch();    
  },
  profiles: 
  {
    smallScreenHeight: function() 
    {
      var IsEmbedded =((Ext.is.Phone) || (Ext.is.Tablet));
      return (IsEmbedded && (screen.height < 480)) || (!IsEmbedded && (window.innerHeight < 480));
    },
    bigScreenHeight: function() 
    {
      var IsEmbedded =((Ext.is.Phone) || (Ext.is.Tablet));
      return (IsEmbedded && (screen.height >= 480)) || (!IsEmbedded && (window.innerHeight >= 480));
    }
  },
  mainLaunch: function()
  {
    if (!this.launched) {return;}
    
    // force small menu on small screens
    if (MyHome.getProfile() === "smallScreenHeight") 
    {
      mainSettings.SetMenuSize("small");    
    }

    function GoToDevicesList(DeviceType, Group)
    {
      MainPanel.setActiveItem(ApplicationStates.Devices);
      setAppNextState(ApplicationStates.Devices);        
      FilteredDeviceList.Get(DeviceType, Group);
    }

    /**********************************************************************
      IN ADVANCE REUSABLE BUTTON DEFINITIONS. THEY ARE LAZY INSTANTIATED
    **********************************************************************/

    BTN_MM_Rooms = 
    {
      id: 'ID_BTN_MM_Rooms',
      label: Language.Application.Menu_Bnt_Rooms,
      handler: function(button)
      {
        MainPanel.setActiveItem(ApplicationStates.Groups);
        setAppNextState(ApplicationStates.Groups);
        CallFilteredGroupList(null);
      }
    }

    BTN_MM_Alarm = 
    {
      id: 'ID_BTN_MM_Alarm',
      label: Language.Application.Menu_Bnt_Alarm,
      handler: function(button)
      {
        Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Menu_Bnt_Alarm);
        GoToDevicesList("motionSensor", null);
      }
    }

    BTN_MM_Lights = 
    {
      id: 'ID_BTN_MM_Lights',
      label: Language.Application.Menu_Bnt_Lights,
      handler: function(button)
      {
        Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Menu_Bnt_Lights);
        GoToDevicesList("switchSensorPower", null);
      }
    }

    BTN_MM_Info = 
    {
      id: 'ID_BTN_MM_Info',
      label: Language.Application.Menu_Bnt_Status,
      handler: function(button)
      {
        Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Devices_Title);
        GoToDevicesList(null, null);
      }
    }

    BTN_MM_Heat = 
    {
      id: 'ID_BTN_MM_Heat',
      label: Language.Application.Menu_Bnt_Heating,
      handler: function(button)
      {
        Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Menu_Bnt_Heating);
        GoToDevicesList("thermalSwitch", null);
      }
    }

    BTN_MM_Camera = 
    {
      id: 'ID_BTN_MM_Camera',
      label: Language.Application.Menu_Bnt_Camera,
      handler: function(button)
      {
        Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Menu_Bnt_Camera);
        GoToDevicesList("captureCamera", null);
      }
    }
    
    BTN_MM_AllOff = 
    {
      id: 'ID_BTN_MM_AllOff',
      label: Language.Application.Menu_Bnt_AllOff,
      handler: function(button)
      {
        DeviceList.TurnAllDevicesOff
        (
          function onComplete(success)
          {
            Ext.Msg.alert(Language.Application.Common_Info, Language.Application.Menu_Devices_AllOff);
          }
        );
      }
    }

    BTN_MM_Cooling = 
    {
      id: 'ID_BTN_MM_Cooling',
      label: Language.Application.Menu_Bnt_Cooling,
      handler: function(button)
      {
        Ext.getCmp('ID_DevicesNav').SetTitle(Language.Application.Menu_Bnt_Cooling);
        GoToDevicesList("thermalSwitch", null);
      }
    }

    BTN_MM_Settings = 
    {
      id: 'ID_BTN_MM_Settings',
      label: Language.Application.Menu_Bnt_Settings,
      handler: function(button)
      {
        setAppNextState(ApplicationStates.Settings);
        MainPanel.setActiveItem(ApplicationStates.Settings);
        DoSelectSettingsState(SettingsStates.SettingsList);
      }
    }

    /**********************************************************************
      TWO DIFFERENT MENU SIZE IMPLEMENTATION PUT TOGETHER FROM TEMPLATES
    **********************************************************************/

    if (mainSettings.GetMenuSize() === "large")
    {
      MenuItems =
      [
        {
          xtype: 'MainMenuColumn',
          items:
          [
            BTN_MM_Rooms,
            BTN_MM_Alarm,
            BTN_MM_Lights
          ]
        },
        {
          xtype: 'MainMenuColumn',
          items:
          [
            BTN_MM_Info,
            BTN_MM_Heat, 
            BTN_MM_Camera
          ]
        },
        {
          xtype: 'MainMenuColumn',
          items:
          [
            BTN_MM_AllOff,
            BTN_MM_Cooling,
            BTN_MM_Settings
          ]
        }
      ];
    }
    else
    {
      MenuItems =
      [
        {
          xtype: 'MainMenuColumn',
          items:
          [
            BTN_MM_Rooms,
            BTN_MM_AllOff
          ]
        },
        {
          xtype: 'MainMenuColumn',
          items:
          [
            BTN_MM_Info,
            BTN_MM_Settings
          ]
        }
      ];
    }

    MainMenu =
    {
      id: 'ID_MainMenu_Panel',
      cls: 'CS_MainMenu_Panel',
      xtype: 'panel',
      layout:
      {
        type: 'vbox',
        pack: 'center',
        align: 'stretch'
      },
	  style: { // dodano zaradi poravnave gumbov
		margin: '0px'
	  },
      items:
      [
        {
          xtype: 'panel',
          height: 77,

          layout:
          {
            type: 'hbox'
          },
          items:
          [
            {
              cls: 'CS_Logout_Container',
             
              height: 77,
              flex: 1,
              layout:
              {
                type: 'hbox',
                pack: 'left'
              },
              items:
              [
                {
                  id: 'ID_Logout_Button',
                  cls: "CS_Logout_Button",
                  xtype: "BackButton",
                  text: Language.Application.Menu_Btn_Logoff,
                  handler: function()
                  {
                    MainPanel.setActiveItem(SetAppPreviousState());
                    LoggedUser.Logout();
                  }
                },
				{
				  // id: this.titleId,
				  cls: "appStateTitleContainer",
				  html: '<div class="appStateTitle"><p>Si.nadzor</p></div>',
				  height: 60,
				  flex: 2
				},
				{
				  xtype: 'panel',
				  html: '<img class="CS_Logo_Small" src="images/logo_small.png">',
				  height: 60,
				  width: 48,
				  flex: 1
				}
              ]
            }
          ]
        },
        {
          id: 'ID_MenuContent',          
          xtype: 'panel',
          flex: 1,
          layout:
          {
            type: 'hbox',
            pack: 'center',
            align: 'stretch'
          },
		  style: {
            backgroundImage: 'url(../images/wrapper_bg.png)',
            backgroundRepeat: 'repeat-x',
            backgroundPosition: 'top left',
			backgroundColor: '#0f1111'
		  },
          defaults:
          {
            flex: 1
          },
          items: MenuItems,
          //padding: "110px 5px 5px 5px"
        }
      ]
    };

    MainPanelBase =
    {
      id: 'ID_Main_Panel',
      cls: 'CS_Main_Panel',
      layout: 'card',
      items:
      [
        StartupPanel,
        AuthPanel,
        MainMenu,
        GroupPanel,
        DevicePanel,
        DetailsPanel,
        AppSettingsPanel,
        DemoRegisterPanel
      ]
    };

    if ((Ext.is.Phone) || (Ext.is.Tablet))
    {
      MainPanelBase.fullscreen = true;
    }
    else
    {     
      Ext.apply(MainPanelBase,
      {
        autoRender     : true,
        floating       : true,
        modal          : true,
        centered       : true,
        hideOnMaskTap  : false,
        height         : 540,
        width          : 400
      });
    }

    MainPanel = new Ext.Panel(MainPanelBase);
    MainPanel.show();
  }
});
