﻿var LanguagesList = 
{
  items: 
  [
    {
      LNGCode: "en-US",
      display: Language.Application.MiscSettings_Language_en_US
    },
    {
      LNGCode: "sl-SI",
      display: Language.Application.MiscSettings_Language_sl_SI
    }
  ]
};

var MenuSizeList = 
{
  items: 
  [
    {
      MenuSizeCode: "large",
      display: Language.Application.MiscSettings_MenuSize_Large
    },
    {
      MenuSizeCode: "small",
      display: Language.Application.MiscSettings_MenuSize_Small
    }
  ]
};

var LanguagesListStore = new Ext.data.Store(
{
  autoLoad: true,
  model: 'Languages',
  data : LanguagesList,
  proxy: 
  {
    type: 'memory',
    reader: 
    {
      type: 'json',
      root: 'items'
    }
  }
});

var MenuSizeListStore = new Ext.data.Store(
{
  autoLoad: true,
  model: 'MenuSizes',
  data : MenuSizeList,
  proxy: 
  {
    type: 'memory',
    reader: 
    {
      type: 'json',
      root: 'items'
    }
  }
});

MiscSettingsForms = 
{
  id: 'ID_MiscSettingsForms',
  cls: 'CS_MiscSettingsForms',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,
  items:
  [
    {
      cls: 'CS_Fieldset_MiscSettings',
      xtype: "fieldset",
      title: Language.Application.MiscSettings_Language,
      items:
      [
        {
          id: 'ID_appLanguage_dropdown',
          cls: 'CS_appLanguage_dropdown',
          name: 'appLanguage',
          xtype: 'selectfield',
          store: LanguagesListStore,
          displayField:'display',
          valueField: 'LNGCode'
        }
      ],
      
      listeners:
      {
        afterrender: function(panel)
        {
          Ext.getCmp('ID_appLanguage_dropdown').setValue(mainSettings.GetLanguage());
        }
      }  
    },
    {
      cls: 'CS_Fieldset_MiscSettings',
      xtype: "fieldset",
      title: Language.Application.MiscSettings_MenuSize,
      items:
      [
        {
          id: 'ID_appMenuSize_dropdown',
          cls: 'CS_appMenuSize_dropdown',
          name: 'appMenuSize',
          xtype: 'selectfield',
          store: MenuSizeListStore,
          displayField:'display',
          valueField: 'MenuSizeCode'
        }
      ],

      listeners:
      {
        afterrender: function(panel)
        {
          Ext.getCmp('ID_appMenuSize_dropdown').setValue(mainSettings.GetMenuSize());
        }
      }  
    }
  ],
    
  setProfile: function (profile) 
  {
    Ext.getCmp('ID_appMenuSize_dropdown').setDisabled(profile === "smallScreenHeight");
  },

  dockedItems:
  [
    {
      id: 'ID_BTN_MiscSettings_Apply',
      cls: 'CS_BTN_ConfirmAction',
      dock: 'bottom',
      xtype: "button",
      text: Language.Application.MiscSettings_Apply,
      ui: "confirm",
	  height: 60,
	  margin: "0px 10px 5px 10px",
	  html: '<img src="images/btn_arrow.png" class="arrow_right" />',
      handler: function()
      {
        var values = Ext.getCmp('ID_MiscSettingsForms').getValues();
        
        if (!!values.appLanguage)
        {
          Ext.Msg.confirm
          (
            Language.Application.MiscSettings_RestartConfirm,
            Language.Application.MiscSettings_RestartApplication,
            function(button)
            {
              if (button === "yes")
              {
                mainSettings.SetLanguage(values.appLanguage);
                mainSettings.SetMenuSize(values.appMenuSize);
                location.reload();
              }
            }
          );          
        }
        else
        {
          Ext.Msg.alert(Language.Application.Common_Error, Language.Application.Common_Form_FillAllFields);
        }
      }
    }  
  ]
};