﻿AddDeviceCaptureCamera =
{
  id: 'ID_AddDeviceCaptureCamera_Form',
  cls: 'CS_AddDeviceCaptureCamera_Form',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,

  items:
  [
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Application.AddDevice_Name,
      items:
      [
        {
          name: "CaptureCamera_deviceName",
          xtype: "textfield",
          placeHolder: Language.Application.AddDevice_Name_Hint
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.CaptureCamera.MISISDN1,
      items:
      [
        {
          placeHolder: Language.Application.AddDevice_NoMISISDN,
          name: "CaptureCamera_misisdn1",
          cls: 'CS_MISISDN_dropdown',
          xtype: 'selectfield',
          store: UnusedMISISDNStore,
          displayField: 'number',
          valueField: 'number'
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.CaptureCamera.MISISDN2,
      items:
      [
        {
          name: "CaptureCamera_misisdn2",
          xtype: "textfield"
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.CaptureCamera.MISISDN3,
      items:
      [
        {
          name: "CaptureCamera_misisdn3",
          xtype: "textfield"
        }
      ]
    }
  ],
  
  isFormValid: function()
  {
    var values = Ext.getCmp('ID_AddDeviceCaptureCamera_Form').getValues();
    return (!!values.CaptureCamera_deviceName && !!values.CaptureCamera_misisdn1);
  },
  
  getAddDeviceProps: function()
  {
    var values = Ext.getCmp('ID_AddDeviceCaptureCamera_Form').getValues();
    var emergencyMsisdnsList = [];
    
    if (values.CaptureCamera_misisdn2)
    {
      emergencyMsisdnsList.push(values.CaptureCamera_misisdn2);
    }
    if (values.CaptureCamera_misisdn3)
    {
      emergencyMsisdnsList.push(values.CaptureCamera_misisdn3);
    }
          
    var DeviceProps = 
    {
      deviceImpl: AddDeviceTypeAndGroup.GetDeviceImpl(),
      deviceMsisdn: values.CaptureCamera_misisdn1,
      emergencyMsisdns: emergencyMsisdnsList,
      name: values.CaptureCamera_deviceName
    }
    
    return DeviceProps;
  },
  
  getFormName: function()
  {
    return "ID_AddDeviceCaptureCamera_Form"
  }
};
