﻿AddDeviceSmartehGM2 =
{
  id: 'ID_AddDeviceSmartehGM2_Form',
  cls: 'CS_AddDeviceSmartehGM2_Form',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,

  items:
  [
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Application.AddDevice_Name,
      items:
      [
        {
          name: "SmartehGM2_deviceName",
          xtype: "textfield",
          placeHolder: Language.Application.AddDevice_Name_Hint
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.SmartehGM2.MISISDN1,
      items:
      [
        {
          placeHolder: Language.Application.AddDevice_NoMISISDN,
          name: "SmartehGM2_misisdn1",
          id: "ID_SmartehGM2_misisdn1",
          cls: 'CS_MISISDN_dropdown',
          xtype: 'selectfield',
          store: UnusedMISISDNStore,
          displayField: 'number',
          valueField: 'number'
        }
      ]
    },
  ],

  Initialize: function()
  {
    var misisdnSelect = Ext.getCmp('ID_SmartehGM2_misisdn1');
        
    if (UnusedMISISDNStore.getCount() > 0)
    {
      misisdnSelect.setValue(UnusedMISISDNStore.getAt(0).get("number"));
      misisdnSelect.enable();
    }
    else
    {
      misisdnSelect.setValue(Language.Application.AddDevice_NoMISISDN);
      misisdnSelect.disable();
    }
  }, 

  isFormValid: function()
  {
    var values = Ext.getCmp('ID_AddDeviceSmartehGM2_Form').getValues();
    return (!!values.SmartehGM2_deviceName && !!values.SmartehGM2_misisdn1 && (UnusedMISISDNStore.getCount() > 0));
  },
  
  getAddDeviceProps: function()
  {
    var values = Ext.getCmp('ID_AddDeviceSmartehGM2_Form').getValues();
              
    var DeviceProps = 
    {
      deviceImpl: AddDeviceTypeAndGroup.GetDeviceImpl(),
      deviceMsisdn: values.SmartehGM2_misisdn1,
      name: values.SmartehGM2_deviceName
    }
    
    return DeviceProps;
  },
  
  getFormName: function()
  {
    return "ID_AddDeviceSmartehGM2_Form"
  }
};
