﻿AddDeviceStripsSocket =
{
  id: 'ID_AddDeviceStripsSocket_Form',
  cls: 'CS_AddDeviceStripsSocket_Form',
  scroll: "vertical",
  xtype: "formpanel",
  bodyPadding: 0,
  padding: 6,

  items:
  [
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Application.AddDevice_Name,
      items:
      [
        {
          name: "StripsSocket_deviceName",
          xtype: "textfield",
          placeHolder: Language.Application.AddDevice_Name_Hint
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.StripsSocket.MISISDN1,
      items:
      [
        {
          placeHolder: Language.Application.AddDevice_NoMISISDN,
          name: "StripsSocket_misisdn1",
          id: "ID_StripsSocket_misisdn1",
          cls: 'CS_MISISDN_dropdown',
          xtype: 'selectfield',
          store: UnusedMISISDNStore,
          displayField: 'number',
          valueField: 'number'
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.StripsSocket.MISISDN2,
      items:
      [
        {
          name: "StripsSocket_misisdn2",
          xtype: "textfield"
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.StripsSocket.ADDRESS,
      items:
      [
        {
          name: "StripsSocket_deviceAddress",
          xtype: "textfield"
        }
      ]
    }
  ],
  
  Initialize: function()
  {
    var misisdnSelect = Ext.getCmp('ID_StripsSocket_misisdn1');
        
    if (UnusedMISISDNStore.getCount() > 0)
    {
      misisdnSelect.setValue(UnusedMISISDNStore.getAt(0).get("number"));
      misisdnSelect.enable();
    }
    else
    {
      misisdnSelect.setValue(Language.Application.AddDevice_NoMISISDN);
      misisdnSelect.disable();
    }
  }, 

  isFormValid: function()
  {
    var values = Ext.getCmp('ID_AddDeviceStripsSocket_Form').getValues();
    return (!!values.StripsSocket_deviceName && !!values.StripsSocket_misisdn1 && !!values.StripsSocket_deviceAddress && (UnusedMISISDNStore.getCount() > 0));
  },
  
  getAddDeviceProps: function()
  {
    var values = Ext.getCmp('ID_AddDeviceStripsSocket_Form').getValues();
    var emergencyMsisdn = null;
    
    if (values.StripsSocket_misisdn2)
    {
      emergencyMsisdn = values.StripsSocket_misisdn2;
    }
              
    var DeviceProps = 
    {
      deviceImpl: AddDeviceTypeAndGroup.GetDeviceImpl(),
      deviceAddress: values.StripsSocket_deviceAddress,
      deviceMsisdn: values.StripsSocket_misisdn1,
      name: values.StripsSocket_deviceName,
      emergencyMsisdn: emergencyMsisdn
    }
    
    return DeviceProps;
  },
  
  getFormName: function()
  {
    return "ID_AddDeviceStripsSocket_Form"
  }
};
