﻿AddDeviceTutaS30Socket =
{
  id: 'ID_AddDeviceTutaS30Socket_Form',
  cls: 'CS_AddDeviceTutaS30Socket_Form',
  scroll: "vertical",
  xtype: "formpanel",
  pinHeaders: true,
  bodyPadding: 0,
  padding: 6,

  items:
  [
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Application.AddDevice_Name,
      items:
      [
        {
          name: "TUTAS30_deviceName",
          xtype: "textfield",
          placeHolder: Language.Application.AddDevice_Name_Hint
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.TUTAS30Socket.MISISDN1,
      items:
      [
        {
          placeHolder: Language.Application.AddDevice_NoMISISDN,
          name: "TUTAS30_misisdn1",
          id: "ID_TUTAS30_misisdn1",
          cls: 'CS_MISISDN_dropdown',
          xtype: 'selectfield',
          store: UnusedMISISDNStore,
          displayField: 'number',
          valueField: 'number'
        }
      ]
    },
    {
      cls: 'CS_Fieldset_AddDevice',
      xtype: "fieldset",
      title: Language.Registrations.Devices.TUTAS30Socket.MISISDN2,
      items:
      [
        {
          name: "TUTAS30_misisdn2",
          xtype: "textfield",
          placeHolder: Language.Application.AddDevice_MISISDN_Hint
        }
      ]
    }
  ],
  
  Initialize: function()
  {
    var misisdnSelect = Ext.getCmp('ID_TUTAS30_misisdn1');
        
    if (UnusedMISISDNStore.getCount() > 0)
    {
      misisdnSelect.setValue(UnusedMISISDNStore.getAt(0).get("number"));
      misisdnSelect.enable();
    }
    else
    {
      misisdnSelect.setValue(Language.Application.AddDevice_NoMISISDN);
      misisdnSelect.disable();
    }
  }, 
  
  isFormValid: function()
  {
    var values = Ext.getCmp('ID_AddDeviceTutaS30Socket_Form').getValues();
    return (!!values.TUTAS30_deviceName && !!values.TUTAS30_misisdn1 && (UnusedMISISDNStore.getCount() > 0));
  },
  
  getAddDeviceProps: function()
  {
    var values = Ext.getCmp('ID_AddDeviceTutaS30Socket_Form').getValues();
    var emergencyMsisdnsList = [];
    
    if (values.TUTAS30_misisdn2)
    {
      emergencyMsisdnsList.push(values.TUTAS30_misisdn2);
    }
          
    var DeviceProps = 
    {
      deviceImpl: AddDeviceTypeAndGroup.GetDeviceImpl(),
      deviceMsisdn: values.TUTAS30_misisdn1,
      emergencyMsisdns: emergencyMsisdnsList,
      name: values.TUTAS30_deviceName
    }
    
    return DeviceProps;
  },
  
  getFormName: function()
  {
    return "ID_AddDeviceTutaS30Socket_Form"
  }
};
