﻿var idGenerator = 1;

getUniqueId = function ()
{
  var dateObject = new Date();
  var uniqueId = dateObject.getFullYear() + '' + 
                 dateObject.getMonth() + '' + 
                 dateObject.getDate() + '' + 
                 dateObject.getTime() + '' +
                 idGenerator;
  idGenerator++ ;
  return uniqueId;
};

MainMenuButton = Ext.extend(Ext.Container, 
{
  label: "",
   
  initComponent: function()
  {
    Ext.apply(this, 
    {
      items:
      [
        {
          width: 80,
          height: 80,
          cls: 'CS_BTN_MainMenu',
          xtype: 'button',
          handler: this.handler
        },
        {
          html: '<div>' + this.label + '</div>',
          cls: 'CS_TXT_MainMenu'
        }
      ]
    });
    
    // Call parent (required)
    MainMenuButton.superclass.initComponent.call(this);
  },
});

MainMenuColumn = Ext.extend(Ext.Container, 
{
  initComponent: function()
  {
    Ext.apply(this, 
    {
      cls: 'CS_MainMenu_Column',
      layout:
      {
        type: 'vbox',
        pack: 'center'
      },
      defaults:
      {
        cls: 'CS_MainMenu_Button',
        xtype: 'MainMenuButton',
        height: 80,
        width: 120,
        flex: 1,
        layout:
        {
          type: 'vbox',
          pack: 'center'
        }
      }
    });
    
    // Call parent (required)
    MainMenuColumn.superclass.initComponent.call(this);
  }
});

BackButton = Ext.extend(Ext.Button, 
{
  initComponent: function()
  {
    Ext.apply(this, 
    {
      id: getUniqueId(),
      ui: "confirm",
      height: 40
    });
  }
});

BackNavigation = Ext.extend(Ext.Container, 
{
  title: "",
  titleId: getUniqueId(),
    
  SetTitle: function(value)
  {
    this.title = value;
    Ext.getCmp(this.titleId).update('<div class="appStateTitle"><p>' + value + '</p></div>');
  },
  
  initComponent: function()
  {    
    this.titleId = getUniqueId();
    
    Ext.apply(this, 
    {
      cls: 'CS_Navigation_Menu',
      // padding: "0px 5px 0px 5px",
      xtype: 'panel',
      height: 77,
      layout:
      {
        type: 'hbox'
      },
      items:
      [
        {
          cls: 'CS_Back_Container',
          height: 60,
          flex: 1,
          layout:
          {
            type: 'hbox',
            pack: 'left '
          },
          items:
          [
            {
              xtype: "BackButton",
              cls: "CS_Back_Button",
              handler: this.handler,
              text: Language.Application.Common_Bnt_Back
            }
          ]
        },
        {
          id: this.titleId,
          cls: "appStateTitleContainer",
          html: '<div class="appStateTitle"><p>' + this.title + '</p></div>',
          height: 60,
          flex: 2
        },
        {
		  xtype: 'panel',
          html: '<img class="CS_Logo_Small" src="images/logo_small.png">',
		  height: 60,
		  width: 48,
          flex: 1
        }
      ]
    });
    
    // Call parent (required)
    BackNavigation.superclass.initComponent.call(this);
  }
});
 
// register xtype to allow for lazy initialization
Ext.reg('MainMenuButton', MainMenuButton);
Ext.reg('MainMenuColumn', MainMenuColumn);
Ext.reg('BackNavigation', BackNavigation);
Ext.reg('BackButton', BackButton);